/***************************************************************************
 *            callbacks.c
 *	
 *  Wed Mar 14 14:49:11 2007
 *  Copyright  2007  hunbuso and cugb_cat
 *  hunbuso@gmail.com
*  xielichao1984@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. ICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "functions.h"

GtkWidget	*win_main = NULL;
GtkWidget *clist_machine = NULL;
GtkWidget *win_message_box = NULL;	
GtkWidget *win_get_message = NULL;
GtkWidget *textview_show_message = NULL;
GtkWidget *statusbar_main = NULL;
GtkWidget *filechooserdialog_send = NULL;
GtkWidget *window_send_files = NULL;
GtkWidget *label_file_num_total = NULL;
GtkWidget *label_file_dest = NULL;
GtkWidget *win_get_files = NULL;
GtkWidget *aboutdialog = NULL;
GtkWidget *filechooserdialog_save_files = NULL;
GtkWidget *clist_get_files = NULL;
GtkWidget	*textview_get_files = NULL;
GtkWidget	*dialog_overwrite_file_confirm = NULL;
GtkWidget	*label_overwrite_file_confirm = NULL;

static gchar *dest_user_name = NULL;	/*被选中主机的用户名*/
static gchar *dest_host_name = NULL;	/*被选中主机的机器名*/
static gchar *dest_address = NULL;	/*被选中主机的IP地址*/
static gboolean select_flag = FALSE;	/*主机有没有选中的标志*/

gboolean
on_win_main_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_main_quit();
  return FALSE;
}


void
on_clist_machine_select_row            (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{	/*鼠标在列表控件上选中某一台计算机的处理函数*/
	gtk_clist_get_text(GTK_CLIST(clist_machine), row, 0, &dest_user_name);
	gtk_clist_get_text(GTK_CLIST(clist_machine), row, 1, &dest_host_name);
	gtk_clist_get_text(GTK_CLIST(clist_machine), row, 2, &dest_address);
	if( !select_flag ){
	select_flag = TRUE;
	}
}


gboolean
on_clist_machine_button_press_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{	/*在主机列表上单击鼠标右键的处理函数*/
	GtkWidget *win_menu_send;
	if(event->button==3)
	{	/*3表示为鼠标右键*/
		win_menu_send = create_menu_send();
		gtk_menu_popup(GTK_MENU(win_menu_send),NULL,NULL,NULL,NULL,event->button,event->time);
	}
  return FALSE;
}


void
on_button_refresh_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{	/*“刷新”按钮的消息处理函数 */
	GtkWidget *label_num_online;
	gchar num_online[4];
	gchar *user_list[3] = {NULL};
	ipmsg_user_list * p=NULL;
	int 		num=0;
	
	clist_machine = lookup_widget(GTK_WIDGET(button),"clist_machine");
	label_num_online = lookup_widget(GTK_WIDGET(button),"label_num_online");
	
	gtk_clist_clear(GTK_CLIST(clist_machine));
	
	p = head;
	p = p->next;
	/*在终端打印，主要于调试用*/
		printf("-----------------------------------------------------------------------------------------------------------\n");
		printf("%4s|%20s|%20s|%20s|%s\n", LOCALE_FROM_UTF8("序号"), LOCALE_FROM_UTF8("用户名"), LOCALE_FROM_UTF8("工作组"), LOCALE_FROM_UTF8("主机名"), "IP");
		printf("----|--------------------|--------------------|--------------------|---------------------------------------\n");

	while (p){
		p->user_num = num;
		num++;
		printf("%4u|%20s|%20s|%20s|%s\n", (unsigned int) p->user_num, LOCALE_FROM_UTF8(UTF8_FROM_GB2312(p->user_name)), LOCALE_FROM_UTF8(UTF8_FROM_GB2312(p->user_group)), LOCALE_FROM_UTF8(UTF8_FROM_GB2312(p->user_machine)), (char *) inet_ntoa(p->user_addr.sin_addr));
		printf("----|--------------------|--------------------|--------------------|---------------------------------------\n");
		user_list[0] =  UTF8_FROM_GB2312(p->user_name);
		user_list[1] =  UTF8_FROM_GB2312(p->user_machine);
		user_list[2] = (char *) inet_ntoa(p->user_addr.sin_addr);
		gtk_clist_append(GTK_CLIST(clist_machine),user_list);
		p = p->next;
		}
	snprintf(num_online, sizeof(num_online), "%d", num);
	gtk_label_set_text(GTK_LABEL(label_num_online),num_online);
	if( select_flag ) {
	select_flag = FALSE;
	}
	show_status(MESSAGE_REFRESH_SUCCESS);
}


void
on_button_send_message_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{	/*点击主窗口的“发送消息”按钮*/
	struct sockaddr_in dest_message;
	struct hostent *host=NULL;
	struct ipmsgdata *data_message = NULL;
	
	data_message = (ipmsgdata*)malloc(sizeof(ipmsgdata));
	if(!data_message)
	{
		show_error(MESSAGE_MEM_ALOC_FAIL);
		return;
	}
	memset( data_message, 0, sizeof(*data_message) );	/*清零*/
	memset( &dest_message, 0, sizeof(dest_message));
	
	if(!select_flag)	
	{
		show_error(MESSAGE_NO_MACHINE_SEL);
		show_status(MESSAGE_NO_MACHINE_SEL);
		return;	/*若没有任何主机被选中*/
	}
	
	host = gethostbyname(dest_address);
	if(!host)
	{
		show_error(MESSAGE_GET_HOST_ERROR);
		return;
	}
	dest_message.sin_family = AF_INET;
	dest_message.sin_port = htons(ipmsgport);
	dest_message.sin_addr = *((struct in_addr *)host->h_addr);
	
	GtkWidget *textview_message = NULL;
	GtkTextBuffer *view_message = NULL;
	GtkTextIter startiter;
	GtkTextIter enditer;
	gchar *message = NULL;
	
	textview_message = lookup_widget(GTK_WIDGET(button),"textview_message");
	view_message = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview_message));
	gtk_text_buffer_get_bounds(view_message, &startiter, &enditer);
	message = gtk_text_buffer_get_text(view_message, &startiter, &enditer, TRUE);
	if(0 == strlen(message))
	{
		show_error(MESSAGE_MESSAGE_EMPTY);
		return;	
	}	/*如果要发的消息为空则退出本函数 */
	strncpy(data_message->append, GB2312_FROM_UTF8(message), sizeof(data_message->append));
	ipmsgsendbcast( & dest_message, IPMSG_SENDMSG, data_message);
	gtk_text_buffer_delete(view_message, &startiter, &enditer);
	free(message);
	free(data_message);	
	show_status(MESSAGE_HAS_BEEN_SENT);
}


void
on_button_message_OK_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{	/*错误警告窗口的“确定”按钮被单击的处理函数*/
	win_message_box = lookup_widget(GTK_WIDGET(button),"win_message_box");
	if(win_message_box){
	gtk_widget_destroy(win_message_box);
	}
}


void
on_sendfile_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	/*传送文件的处理函数*/
	if(!select_flag)
	{
		show_status(MESSAGE_NO_MACHINE_SEL);
		return;	
	}	/*若没有任何主机被选中*/
	filechooserdialog_send = create_filechooserdialog_send();
	gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(filechooserdialog_send), getenv("HOME"));
	gtk_widget_show(filechooserdialog_send);
	show_status(MESSAGE_TOO_MANY_FILES);
}


void
on_sendfolder_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	/*传送文件夹的处理函数*/
	if(!select_flag)
	{
		show_status(MESSAGE_NO_MACHINE_SEL);
		return;	/*若没有任何主机被选中*/
	}
	show_error(MESSAGE_NOT_COMPLETE);	/*未完成*/
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	aboutdialog = create_aboutdialog();
	gtk_widget_show_all(aboutdialog);
}


void
on_win_get_message_show                (GtkWidget       *widget,
                                        gpointer         user_data)
{	/*当watch_net线程获取到消息*/
	GtkTextBuffer *text_buffer_message = NULL;
	GtkWidget *label_user_machine;
	GtkWidget *label_time;
	gchar *wday[]={"星期日","星期一","星期二","星期三","星期四","星期五","星期六"};
	gchar buffer[MAX_USER_NAME_LENGTH+HOSTNAME_LENGTH];
	gchar buffer_t[100];
	time_t timep;
	struct tm *p = NULL;
		
	memset(buffer, 0, sizeof(buffer));
	memset(buffer_t, 0, sizeof(buffer_t));
	textview_show_message = lookup_widget(widget, "textview_show_message");
	label_user_machine = lookup_widget(widget, "label_user_machine");
	label_time = lookup_widget(widget, "label_time");
	time(&timep);
	p=localtime(&timep);	/*获取本地系统时间*/
	snprintf(buffer, sizeof(buffer), "%s  (%s)  %s", data_rev->sendername, data_rev->senderhost, data_rev->ip);
	snprintf(buffer_t, sizeof(buffer_t), "时间：%d-%d-%d %s %d 时 %d 分 %d 秒", (1900+p->tm_year), (1+p->tm_mon), p->tm_mday, wday[p->tm_wday], p->tm_hour, p->tm_min, p->tm_sec);
	gtk_label_set_text(GTK_LABEL(label_user_machine), buffer);
	gtk_label_set_text(GTK_LABEL(label_time), buffer_t);
	text_buffer_message = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview_show_message));
	gtk_text_buffer_set_text(text_buffer_message, UTF8_FROM_GB2312(data_rev->append), strlen(UTF8_FROM_GB2312(data_rev->append)));	
}


void
on_button_cancel_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{	/*点击“取消”按钮*/
	if(win_get_message) {
	gtk_widget_destroy(win_get_message);
	win_get_message = NULL;
	}
}


void
on_button_reply_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{	/*点击“回复”按钮*/
	if(win_get_message) {
	gtk_widget_destroy(win_get_message);
	win_get_message = NULL;
	}
}


void
on_filechooser_button_cancel_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
	if(filechooserdialog_send) {
	gtk_widget_destroy(filechooserdialog_send);
	filechooserdialog_send = NULL;
	}
}


void
on_filechooser_button_open_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	GSList* filenames = NULL;
	gchar *filepath[1] = {NULL};
	if( filechooserdialog_send ) {
	filenames = gtk_file_chooser_get_filenames(GTK_FILE_CHOOSER(filechooserdialog_send));
	}
	
	if( !filenames ) {
		return;
	}
	
	window_send_files = create_window_send_files();
	gtk_widget_show_all(window_send_files);
	gtk_widget_destroy(filechooserdialog_send);
	filechooserdialog_send = NULL;	//hunbuso
	
	GtkWidget *clist_file_selected;
	clist_file_selected = lookup_widget(GTK_WIDGET(window_send_files), "clist_file_selected");
	g_print("[files below will be sent:]\r\n\n");
	
	int num = 0;
	arg = (sendfilearg *)malloc(sizeof(sendfilearg));
	while(filenames)
	{	
		filepath[0] = UTF8_FROM_LOCALE(filenames->data);
		strncpy(arg->filename[num], filepath[0], PATH_MAX);
		arg->fileattr[num] = IPMSG_FILE_REGULAR;
		gtk_clist_append(GTK_CLIST(clist_file_selected), filepath);
		g_print("%s\n", UTF8_FROM_LOCALE(filenames->data));
		num ++;
		filenames = g_slist_next(filenames);
	}
	
	arg->filenum = num;
	arg->flags = 3;	/*sendfiles in IP methed*/
	strncpy(arg->to, dest_address, sizeof(arg->to)); /*dest host IP*/
	
	printf("\n%d file has been selected\n",num);
	g_slist_free(filenames);	/* don't forget free */
	
	if(num > MAXFILESEND)
	{
		show_error(MESSAGE_TOO_MANY_FILES);
		if(window_send_files) {
			gtk_widget_destroy(window_send_files);
			window_send_files = NULL;
		}
		return;
	}	/*for safe,max 20 files to be sent*/
	
	gchar total_num[20] = {'\0'};
	gchar dest_pc[100] = {'\0'};
	label_file_num_total = lookup_widget(GTK_WIDGET(window_send_files), "label_file_num_total");
	label_file_dest = lookup_widget(GTK_WIDGET(window_send_files), "label_file_dest");
	snprintf(total_num, sizeof(total_num), "总共 %d 个文件", num);
	gtk_label_set_text(GTK_LABEL(label_file_num_total), total_num);
	snprintf(dest_pc, sizeof(dest_pc), "对方用户名:%s 主机名:%s IP地址:%s", dest_user_name, dest_host_name, dest_address);
	gtk_label_set_text(GTK_LABEL(label_file_dest), dest_pc);
}


void
on_button_win_send_confirm_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	int res;
	if(!arg) {
		return;
	}
	res = pthread_create(&id_sendfiles, NULL, sendfiles, (void *)arg);
	if( res != 0 )
	{
		show_error(MESSAGE_CREATE_PS_FAIL);
		exit(1);
	}
	
	show_status(MESSAGE_FILES_HAS_SENT);
	gtk_widget_destroy(window_send_files);
	window_send_files = NULL;
}


void
on_button_win_send_cancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
	if(arg) {
		free(arg);
		arg = NULL;
	}
	if(window_send_files) {
	gtk_widget_destroy(window_send_files);
	window_send_files = NULL;
	}
}


void
on_win_get_files_show                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
	GtkWidget *label_files_machine;
	GtkWidget *label_files_time;
	gchar buffer[MAX_USER_NAME_LENGTH+HOSTNAME_LENGTH] = {'\0'};
	gchar buffer_t[100] = {'\0'};
	time_t timep;
	struct tm *p = NULL;
	
	gchar *wday[]={"星期日","星期一","星期二","星期三","星期四","星期五","星期六"};
	time(&timep);
	p=localtime(&timep);	/*获取本地系统时间*/
	label_files_machine = lookup_widget(GTK_WIDGET(win_get_files), "label_files_machine");
	label_files_time = lookup_widget(GTK_WIDGET(win_get_files), "label_files_time");
	snprintf(buffer, sizeof(buffer), "%s (%s)  %s", UTF8_FROM_GB2312(data_rev->sendername), UTF8_FROM_GB2312(data_rev->senderhost), data_rev->ip);  
	snprintf(buffer_t, sizeof(buffer_t), "时间：%d-%d-%d %s %d 时 %d 分 %d 秒", (1900+p->tm_year), (1+p->tm_mon), p->tm_mday, wday[p->tm_wday], p->tm_hour, p->tm_min, p->tm_sec);
	gtk_label_set_text(GTK_LABEL(label_files_machine), buffer);
	gtk_label_set_text(GTK_LABEL(label_files_time), buffer_t);
	
	gchar *file_list[2] = {NULL};
	clist_get_files = lookup_widget(GTK_WIDGET(win_get_files), "clist_get_files");
	gtk_clist_clear(GTK_CLIST(clist_get_files));
	int i = 0;
	char size[20]={'\0'};
	for( i =0; i < filenum; i++){
	memset(size, 0, sizeof(size));
	snprintf(size, sizeof(size), "%d   Byte", (int)files[i].size);
	file_list[0] = UTF8_FROM_GB2312(files[i].filename);
	file_list[1] = size;
	gtk_clist_append(GTK_CLIST(clist_get_files),file_list);
	}
	
/*
	textview_get_files = lookup_widget(GTK_WIDGET(win_get_files), "textview_get_files");
	GtkTextBuffer	*textview_get_files_buffer = NULL;
	textview_get_files_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview_get_files));
	gtk_text_buffer_set_text(textview_get_files_buffer, UTF8_FROM_GB2312(data_rev->append), strlen(UTF8_FROM_GB2312(data_rev->append)));
*/
}


void
on_button_save_files_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
//	show_error(MESSAGE_NOT_COMPLETE);	
/*
	if( win_get_files ) {
		gtk_widget_destroy(win_get_files);
		win_get_files = NULL;
	}
*/
	if( filenum < 1 ) {
		show_error(MESSAGE_NO_FILE_RECIVE);
		return;
	}
	
	filechooserdialog_save_files = create_filechooserdialog_save_files();
	gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(filechooserdialog_save_files), getenv("HOME"));
	gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(filechooserdialog_save_files), UTF8_FROM_GB2312(files[filenum-1].filename));
	gtk_widget_show_all(filechooserdialog_save_files);
	
	

//	void *pthread_result;


/*	
	if( pthread_join(id_getfiles, &pthread_result) != 0 ) {
		perror("Join thread failed!\n");
		exit(1);
	}
*/
//	filenum--;
	return;	
}


void
on_button_get_file_cancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
	if( win_get_files ) {
	gtk_widget_destroy(win_get_files);
	win_get_files = NULL;
	}
}

void
on_button_filechooserdialog_save_files_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	if( filechooserdialog_save_files ) {
		gtk_widget_destroy(filechooserdialog_save_files);
		filechooserdialog_save_files = NULL;
	}
}

void
on_button_filechooserdialog_save_files_open_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	char *selecte_filename = NULL;
	
	memset(path_save_files, 0, sizeof(path_save_files));

	selecte_filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(filechooserdialog_save_files));
	strncpy(path_save_files, selecte_filename, sizeof(path_save_files));
	
	printf("%s\n", selecte_filename);
	int res;
	writeflag = 0;
	res = pthread_create( &id_getfiles, NULL, getfiles, (void *) datafortcp);
	if( res != 0 ) {
		perror("Create thread failed!\n");
		exit(1);
	}
}

void
on_cancelbutton_overwrite_file_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	if( dialog_overwrite_file_confirm ) {
		gtk_widget_destroy(dialog_overwrite_file_confirm);
		dialog_overwrite_file_confirm = NULL;
	}
	
	if( id_getfiles ) {
		if (pthread_cancel(id_getfiles) != 0) {
			perror("pthread_cancel");
		}
	}
	writeflag = 0;
}


void
on_okbutton_overwrite_file_OK_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
	if( dialog_overwrite_file_confirm ) {
		gtk_widget_destroy(dialog_overwrite_file_confirm);
		dialog_overwrite_file_confirm = NULL;
	}
	writeflag = 1;
}


void
on_dialog_overwrite_file_confirm_show  (GtkWidget       *widget,
                                        gpointer         user_data)
{
	char buffer[256];
	label_overwrite_file_confirm = lookup_widget(GTK_WIDGET(dialog_overwrite_file_confirm), "label_overwrite_file_confirm");
	snprintf(buffer, sizeof(buffer), "文件 %s 已经存在, 替换掉它吗?", UTF8_FROM_GB2312(files[filenum-1].filename));
	gtk_label_set_text(GTK_LABEL(label_overwrite_file_confirm), buffer);
	
}
