/***************************************************************************
 *            functions.c
 *
 *  Mon Apr  9 21:03:03 2007
 *  Copyright  2007  hunbuso and cugb_cat
 *  hunbuso@gmail.com
 * xielichao1984@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 #include "callbacks.h"
 #include "interface.h"
 #include "functions.h"
 
 int		soc;
 int		ipmsgport = DEFAULTPORT;
 int		filenum;
 int		sendcheckflag;		/*标记发送命令中是否含有发送检查标志，1为含有，0为不含*/
 int		repeatflag;			/*是否重发标志*/
 int		recvflag = 0;
 int		startsendflag = 0;	/*开始发送标志*/
 int		arrivetimeflag = 0;	/*检查是否到时，以确定是否重发*/
 int		FileID = 0;				/*记录对方请求发送的文件号*/
 int		trans_file_socs[8];		/*最多只能同时8个socket进行文件传输*/
 int		writeflag = 0;		/*if file exist,write when it's set 1,don't write when it's set 0*/
 unsigned int pocketnos;	/*用来记录发送出去的包的编号，用来和返回的数据包的编号进行核对*/
 unsigned int pocketnos_get;	/*用来记录别人发过来的包的编号，接收文件线程中使用*/
 socklen_t	fromlen;
 char	*user = NULL;
 char	*group = "Linux";	/*my group*/
 char	hostname[HOSTNAME_LENGTH] = {'\0'};
 char	path_save_files[MAX_FILE_NAME] = {'\0'};	/*path to save the files got*/
 char	bcastaddrstr[] = "255.255.255.255";
 char 	buff[8192];
 char	buffer[MAXSOCKBUF*2];
 
 pthread_t	id;				/*用于网络监控*/
 pthread_t	id_sendfiles;		/*发送文件/文件夹*/
 pthread_t	id_getfiles;		/*用于建立TCP链接，进行文件传输*/
 struct	ipmsguser		*head = NULL, *tail = NULL;
 struct	sockaddr_in		me;
 struct sockaddr_in 	me_tcp;
 struct sockaddr_in		bcast;
 struct sockaddr_in		from;
 struct sockaddr_in		trans_file_from[8];		/*8个用户同时向本机传文件*/
 struct transfileheader	files[MAXTRANSFILENUM];
 struct ipmsgdata		* datafortcp = NULL;
 struct ipmsgdata		*data_rev = NULL;	/* 接收到的数据 */	 
 struct sendfilearg		*arg = NULL;
 
ipmsg_user_list * adduser(struct sockaddr_in * useraddrs, struct ipmsguser * q, ipmsgdata * data)
{
	ipmsg_user_list * p = NULL;
	char 		buf[PATH_MAX * 2 + 1] = {'\0'};
	char		*t = NULL, *tt = NULL;
	
	p = (struct ipmsguser *) malloc(sizeof(struct ipmsguser));
	if (!p) {
		perror("malloc:");
		exit(1);
	}
	
	memcpy( &(p->user_addr), useraddrs, sizeof(struct sockaddr_in));
	strncpy(p->user_name, data->sendername, sizeof(p->user_name));
	//p->user_name = strdup(data->sendername);
	strncpy(p->user_machine, data->senderhost, sizeof(p->user_machine));
	//p->user_machine = strdup(data->senderhost);
	strncpy(buf, data->append, sizeof(buf));
	//buf = strdup(data->append);
	memset(p->user_group, 0, sizeof(p->user_group));
	memset(p->user_nick, 0, sizeof(p->user_nick));
	if (buf[0]) {
		tt = strchr(buf, '\a');
		t = strtok(buf, "\a");
		if (t) {
			strncpy(p->user_nick, t, sizeof(p->user_nick));
			//t = strtok(NULL, "\a");
			if (tt) {
				t = t + strlen(t) + 1;
				strncpy(p->user_group, t, sizeof(p->user_group));
			}
		}
		//p->user_group = strtok(NULL, "\a");
	}
	else {
		//p->user_nick = NULL;
		//p->user_group = NULL;
		memset(p->user_nick, 0, sizeof(p->user_nick));
		memset(p->user_group, 0, sizeof(p->user_group));
	}
	
	p->pre = q;
	p->next = NULL;
	q->next = p;
	q = q->next;
	
	return q;
}

char user_exist(struct sockaddr_in * useraddr, ipmsgdata * data)	/*判断用户列表是否存在useraddr用户，存在返回0不存在返回1*/
{
	ipmsg_user_list * p = NULL;
	
	p = head->next;
	
	while (p) {
		if (!strcmp(p->user_name, data->sendername) && !strcmp(p->user_machine, data->senderhost) \
				&& !memcmp( &(p->user_addr), useraddr, sizeof(struct sockaddr_in)))
			return 0;
		p = p->next;
	}
	
	return 1;
}

void del_user(struct sockaddr_in * useraddr, ipmsgdata * data)	/*删除用户*/
{
	ipmsg_user_list * p = NULL;
	
	p = head->next;
	
	while (p) {
		if(!strcmp(p->user_name, data->sendername) && !strcmp(p->user_machine, data->senderhost) \
				&& !memcmp( &(p->user_addr), useraddr, sizeof(struct sockaddr_in))) {
			if(p->next == NULL) {
				p->pre->next = NULL;
				free(p);
				return;
			}
			p->pre->next = p->next;
			p->next->pre = p->pre;
			free(p);
			return;
		}
		p = p->next;
	}
	
	return;
}

void del_all_user()
{
	ipmsg_user_list * p = NULL, * q = NULL;
	
	p = head->next;
	head->next = NULL;
	tail = head;
	
	while (p) {
		q = p;
		p = p->next;
		free(q);
	}
}
//从在线用户列表中查询,可以按在线用户的序号、用户的IP地址或者用户名来进行查询，返回找到的节点的指针，找不到返回NULL
//若按在线用户的编号来查询，则后两个参数均赋值为NULL,若按IP地址查询,则第一和第三个参数为NULL，同理按用户名查询
//若都三个参数中有不止一个不为NULL，则按用户编号、IP地址、用户名的顺序来进行查询
ipmsg_user_list * search_user(unsigned int *usernum,struct in_addr *useraddr,char *username)
{
	ipmsg_user_list * p =head->next;
	
	if (usernum != NULL) {
		while (p) {
			if ( * usernum == p->user_num)
				return p;
			p = p->next;
		}
		
		return p;
	}
	else if (useraddr != NULL) {
		while (p) {
			if (!memcmp(useraddr, & (p->user_addr.sin_addr), sizeof(struct sockaddr_in)))
				return p;
			p = p->next;
		}
		
		return p;
	}
	else if (username != NULL) {
		while (p) {
			if (!strcmp(username, p->user_name))
				return p;
			p = p->next;
		}
		
		return p;
	}
	
	return NULL;
} 
 
 void *watch_net(void *arg)
 {
	 int optval = 1;
	 unsigned int com;
	 struct in_addr	bcastaddr;
	 struct ipmsguser *p = NULL;
	 ipmsgdata	*data = NULL;
		 
	 head = (struct ipmsguser *) malloc(sizeof(struct ipmsguser));
	 if( !head ){
		 perror("malloc failed");
		 exit(1);
	 }
	 
	head->next = NULL;
	head->pre = NULL;
	p = head;		 
	tail = head;
	 
	 if((soc =socket(AF_INET, SOCK_DGRAM, 0)) < 0 ){
		 perror("socket failed");
		 exit(1);
	 }
	 memset( (char * ) ( & me), 0, sizeof(me));
	 me.sin_family = AF_INET;
	 me.sin_port = htons(ipmsgport);
	 me.sin_addr.s_addr = INADDR_ANY;
	 
	 if ( -1 == setsockopt(soc, SOL_SOCKET, SO_BROADCAST, & optval, sizeof(optval)) ){
		 perror("setsockopt failed");
		 exit(1);
	 }
	 
	 if( -1 == bind(soc, (struct sockaddr*) &me, sizeof(me)) ){
		 perror("bind failed");
		 exit(1);
	 }
	 
	 if( -1 == gethostname(hostname, HOSTNAME_LENGTH) ){
		 perror("gethostbyname");
		 exit(1);
	 }
	 
	 if( !(user = getenv("USER"))){
		 perror("getenv (User)");
		 exit(1);
	 }
	 
	 if( 0 == inet_aton(bcastaddrstr, & bcastaddr) ){
		 perror("inet_aton");
		 exit(1);
	 }
	 
	 memset( (char * ) & bcast, 0, sizeof(bcast));
	 com = IPMSG_BR_ENTRY;
	 bcast.sin_family = AF_INET;
	 bcast.sin_port = htons(ipmsgport);
	 bcast.sin_addr = bcastaddr;
	 ipmsgsendbcast( & bcast, IPMSG_NOOPERATION, data);
	 ipmsgsendbcast( & bcast, com, data);

	 while(1){
		 recvfrom(soc, buff, 8192, 0, (struct sockaddr * ) & from, & fromlen);
		 data = (ipmsgdata * ) malloc(sizeof(struct ipmsgdata));
		 memset(data, 0, sizeof(data));
		 data->ip = inet_ntoa(from.sin_addr);
		 data_rev = data;	//hunbuso
		 ipmsgswitch(data, buff);
		 free(data);
	 }
	 
	 return NULL;
 }

 
 
 
 void	ipmsgsendbcast(struct sockaddr_in * dest, unsigned int com, ipmsgdata * data)
 {	/*发送消息*/
	 time_t	now = time(NULL);
	 int	len = 0;
	 memset(buffer, 0, sizeof(buffer));
	 
	 switch(GET_MODE(com)) {
		 case IPMSG_NOOPERATION:
			 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:", (unsigned int ) now, user, hostname, com);
		 	 len = strlen(buffer) + 1;
		 	break;
		 case IPMSG_BR_ENTRY:
			 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:%s", (unsigned int ) now, user, hostname, com, user);
		 	len = strlen(buffer) + 1;
		 	break;
		 case IPMSG_ANSENTRY:
			 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:%s", (unsigned int ) now, user, hostname, com, user);
		 	len = strlen(buffer) + 1;
		 	break;
		 case IPMSG_BR_EXIT:
			 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:%s", (unsigned int ) now, user, hostname, com, user);
		 	len = strlen(buffer) + 1;
		 break;
		 case IPMSG_RECVMSG:
			 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:%u", (unsigned int ) now, user, hostname, com, data->packetno);
		 	len = strlen(buffer) + 1;
		 break;
		 case IPMSG_SENDMSG:
			 if( data->append[0] != '\0' ) {
				 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:%s", (unsigned int ) now, user, hostname, com, data->append);
			 } else{
				 snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%u:", (unsigned int ) now, user, hostname, com);
			 }
			 len = strlen(buffer) + 1;
			 strncpy(buffer+len, data->sendfileheader, sizeof(buffer)-len);
			 
			 if( GET_OPT(com) & IPMSG_FILEATTACHOPT ) {
				 len += strlen(buffer + len) + 1;
			 }
			 if( GET_OPT(com) & IPMSG_SENDCHECKOPT ) {
				 pocketnos = now;
				 sendcheckflag = 1;
			 } else {
				 sendcheckflag = 0;
			 }
		break;	 
	 }
	 sendto(soc, buffer, len, 0, (struct sockaddr * ) dest, sizeof(struct sockaddr_in));
 }
 
 /******************************************************************
 *
 *			hunbuso@gmail.com
 *
 *******************************************************************/
 void ipmsgswitch(ipmsgdata * data, char * buff)
 {	/*收到的消息内容及对收到的消息的反应*/
	 int 	lens=strlen(buff);
	 int fileid;
	 int	fileattr;
	 unsigned int com_opt;
	 unsigned int mtime;
	 unsigned int offset;
	 unsigned long packetnoss;
	 unsigned long long size;
	 char	*buf = NULL;
	 char	*t = NULL;
	 char	*t2 = NULL;
	 char	*temp = NULL;
	 char	filename[PATH_MAX] = {'\0'};
	 
	 buf = strtok(buff, ":");
	 if(buf)
		 sscanf(buf, "%d", & (data->version));
	 buf = strtok(NULL, ":");
	 if(buf) {
		 sscanf(buf, "%d", & (data->packetno));
		 pocketnos_get = data->packetno;
	 }
	 buf = strtok(NULL, ":");
	 if(buf)
		 strncpy(data->sendername, buf, sizeof(data->sendername));
	 buf = strtok(NULL, ":");
	 if(buf)
		 strncpy(data->senderhost, buf, sizeof(data->senderhost));
	 buf = strtok(NULL, ":");
	 if(buf)
		 sscanf(buf, "%u", & (data->com));
	 buf = buf + strlen(buf) + 1;
	 if(buf)
		 strncpy(data->append, buf, sizeof(data->append));
	 
	 switch ( GET_MODE(data->com)) {
		 case IPMSG_NOOPERATION:	/*什么都不做*/
			 break;
		 case IPMSG_BR_ENTRY:		/*有人上线了*/
			 if(user_exist( & from, data))
				 tail = adduser( & from, tail, data);
			 ipmsgsendbcast(& from, IPMSG_ANSENTRY, data);	/*报告自己也在线*/
			 break;
		 case IPMSG_ANSENTRY:		/*对方回应*/
			 if(user_exist( & from, data))
				 tail = adduser( & from, tail, data);
			 break;
		case IPMSG_BR_EXIT:			/*对方下线*/
			if( !user_exist( &from, data))
				del_user( & from, data);
			break;
		case IPMSG_SENDMSG:			/*接收到消息*/
			com_opt = GET_OPT(data->com);
			if( com_opt & IPMSG_SENDCHECKOPT ) {
				ipmsgsendbcast( & from, IPMSG_RECVMSG, data);
			}	/*如果对方需要回复，则回复一个消息通报自己已经接到了包*/
			if( com_opt & IPMSG_FILEATTACHOPT ) {	/*如果是传送文件或者文件夹*/
			strncpy(data->sendfileheader, (buff + lens + 1), sizeof(data->sendfileheader));
				buf = strtok( (data->sendfileheader), "\a");
				
				while (buf) {
					sscanf(buf, "%x", & fileid);
					t = buf;
					t = strstr(t, ":");
					t2 = strstr(t + 1, ":");
					memset(filename, 0, sizeof(filename));
					strncpy(filename, t + 1, t2 - t - 1);
					sscanf(t2 + 1, "%llx:%x", & size, & mtime);
					t2 = strstr(t2 + 1, ":");
					t = strstr(t2 + 1, ":");
					sscanf(t + 1, "%d", & fileattr);
					temp = filename;
					while( (temp = strstr(temp, "::")))
						strncpy(temp + 1, temp + 2, sizeof(temp+1));
					files[fileid].fileID = fileid;
					strncpy(files[fileid].filename, filename, sizeof(files[fileid].filename));
					files[fileid].size = size;
					files[fileid].mtime = mtime;
					files[fileid].fileattr = fileattr;
					buf = strtok(NULL,"\a");
				}
				
				filenum = fileid + 1;
				memcpy( & trans_file_from[0], & from,  sizeof(struct sockaddr_in));
				datafortcp = data;
				printf("get files from %s(%s)\n", data->sendername, data->ip);
				
				gdk_threads_enter();
				win_get_files = create_win_get_files();
				gtk_widget_show_all(win_get_files);		/*show window*/
				show_status(MESSAGE_RECIVE_FILES);
				gdk_threads_leave();
			} 
			else if( data->append[0] ) {
				printf("get msg from %s(%s)\n", LOCALE_FROM_UTF8(UTF8_FROM_GB2312(data->sendername)), data->ip);
				printf("%s\n", LOCALE_FROM_UTF8(UTF8_FROM_GB2312(data->append)));
				
				gdk_threads_enter();	/* 进入线程 */
				win_get_message = create_win_get_message();	/* 创建一个窗口弹出消息 */
				gtk_widget_show_all(win_get_message);
				gdk_threads_leave();	/* 离开线程 */
			}
			break;
		case IPMSG_RECVMSG:		/*收到对方接收到消息的回应*/
			if ( (unsigned int ) atol(data->append) == pocketnos) {
				sendcheckflag = 0;
				repeatflag = 0;
				recvflag = 1;
				show_status(MESSAGE_SEND_SUCCESFUL);
			}
			break;
		case IPMSG_GETFILEDATA:	/*对方请求通过TCP传输文件*/
				sscanf( data->append, "%lx:%x:%x", &packetnoss, &fileid, &offset);
				if ( packetnoss == pocketnos) {
					startsendflag = 1;
					FileID = fileid;
				}
			break;
		case IPMSG_GETDIRFILES:	/*对方请求传输文件夹*/
				sscanf(data->append, "%lx:%x", &packetnoss, &fileid);
				if (packetnoss == pocketnos) {
					startsendflag = 1;
					FileID = fileid;
				}
			break;
		case IPMSG_RELEASEFILES:	/*停止接收文件*/
				if( (unsigned int )atol(data->append) == pocketnos) {
					if (pthread_cancel(id_sendfiles) != 0) {
						perror("pthread_cancel");
						break;
					}
				}
			break;				
	 }	/* end switch */	 
 }

 void * sendfiles(void * arg)
 {
	int 		sockfdTCP;
	int			sockfd;
	unsigned int 		userid;
	ipmsg_user_list * p = NULL;
	char 		UDPsendbuf[MAX_SEND_FILE_HEADER_LEN] = {'\0'};
	char 		UDPsendtemp[MAXSOCKBUF] = {'\0'};
	char		TCPsendbuf[1449] = {'\0'};
	char		TCPtemp[1449] = {'\0'};
	char		* t = NULL, * tt = NULL;
	sendfilearg 	* args = (sendfilearg * ) arg;
	int 		i;
	struct stat 	filestruct;
	ipmsgdata 	data;
	struct in_addr 	addr_temp;
	time_t		time1,time2;
	FILE		* fp = NULL;
	ssize_t		numbytes;
	struct sockaddr cliaddr;
	socklen_t	addrlen;
	int		sendfilenum = args->filenum;
	int		malloc_flag = 0;
	char		filename_temp[PATH_MAX + 1];
	
	/*设置本线程的状态为接收到cancel信号后取消本线程*/
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);

	memset(UDPsendbuf, 0, sizeof(UDPsendbuf));
	memset( & data, 0, sizeof(data));
	if (args->flags == 1) {
		userid = atoi(args->to);
		p = search_user( & userid, NULL, NULL);
	}
	
	if (args->flags == 3) {
		if (inet_aton (args->to, & addr_temp) == 0) {
			perror("inet_aton error");
			return NULL;
		}
		
		p = search_user(NULL, & addr_temp, NULL);
		
		if (!p) {
			p = (ipmsg_user_list * )malloc(sizeof(ipmsg_user_list));
			malloc_flag = 1;
			bzero( &(p->user_addr), sizeof(p->user_addr));
			p->user_addr.sin_family = AF_INET;
			memcpy( & p->user_addr.sin_addr, & addr_temp, sizeof(addr_temp));
			p->user_addr.sin_port = htons(DEFAULTPORT);
		}
	}
	
	if(args->flags == 4)
		p = search_user(NULL, NULL, args->to);
	
	if (!p) {
		printf("There is not this user!\n");
		return NULL;
	}
	
	if (args->flags == 2) {	/*向所有人发送时*/
	
	}
	
	for (i = 0; i < args->filenum - 1; i++) {
		if (stat(LOCALE_FROM_UTF8(args->filename[i]), & filestruct) == -1) {
			perror("stat error");
			return NULL;
		}
		
		t = strchr(args->filename[i], ':');
		while (t) {
			memmove(t + 1, t, strlen(t) + 1);
			* t = ':';
			t = strchr(t + 2, ':');
		}
		strncpy(filename_temp, args->filename[i], sizeof(filename_temp));
		t = strrchr(filename_temp, '/');
		if (t && (*(t + 1) == '\0')) {
			*t = '\0';
			t = strrchr(filename_temp, '/');
			memmove(filename_temp, t + 1, strlen(t + 1) + 1);
		}
		else if (t && ( *(t + 1) != '\0'))
			memmove(filename_temp, t + 1, strlen(t + 1) + 1);
		snprintf(UDPsendtemp, sizeof(UDPsendtemp), "%x:%s:%lx:%lx:%lu:\a", (unsigned int)i, \
				GB2312_FROM_UTF8(filename_temp), filestruct.st_size, filestruct.st_mtime, args->fileattr[i]);
		
		strncat(UDPsendbuf, UDPsendtemp, sizeof(UDPsendbuf));
	}
	
	
	t = strchr(args->filename[i], ':');
	while (t) {
		memmove(t + 1, t, strlen(t) + 1);
		* t = ':';
		t = strchr(t + 2, ':');
	}
	if (stat(LOCALE_FROM_UTF8(args->filename[i]), & filestruct) == -1) {
		perror("stat error");
		printf("%s\n", LOCALE_FROM_UTF8(args->filename[i]));;
		return NULL;
	}
	
	strncpy(filename_temp, args->filename[i], sizeof(filename_temp));
	t = strrchr(filename_temp, '/');
	if (t && (*(t + 1) == '\0')) {
		*t = '\0';
		t = strrchr(filename_temp, '/');
		memmove(filename_temp, t + 1, strlen(t + 1) + 1);
	}
	else if (t && ( *(t + 1) != '\0'))
		memmove(filename_temp, t + 1, strlen(t + 1) + 1);
	
	snprintf(UDPsendtemp, sizeof(UDPsendtemp), "%x:%s:%04lx:%lx:%lu:", \
			(unsigned int)i, GB2312_FROM_UTF8(filename_temp), filestruct.st_size, filestruct.st_mtime, args->fileattr[i]);
	
	strncat(UDPsendbuf, UDPsendtemp, sizeof(UDPsendbuf));
	strncpy(data.sendfileheader, UDPsendbuf, sizeof(data.sendfileheader));
	ipmsgsendbcast( & (p->user_addr), IPMSG_SENDMSG | IPMSG_FILEATTACHOPT | IPMSG_SENDCHECKOPT, & data);

	i = 0;
	arrivetimeflag = 1;
#if 1	
	while (1) {		/*超时重发*/
		time1 = time(NULL);
		if (repeatflag && arrivetimeflag) {
			ipmsgsendbcast( & (p->user_addr), \
					IPMSG_SENDMSG | IPMSG_FILEATTACHOPT | IPMSG_SENDCHECKOPT, & data);
			repeatflag = 0;
			i++;
		}
		time2 = time(NULL);
		
		if ( (time2 - time1) < MAXREPEATTIME && !recvflag) {
			arrivetimeflag = 0;
			continue;
		}
		else
			arrivetimeflag = 1;
		
		if (recvflag)
			break;
		
		if (i > 5) {
			printf("send failed!\n");
			return NULL;
		}
	}
#endif
#if 1	
	if ( (sockfdTCP = socket(AF_INET, SOCK_STREAM, 0)) < 0) {	/*建立TCP监听*/
		perror("socket error");
		return NULL;
	}
	
	int timeout_t = 1;	//hunbuso
	if ( setsockopt(sockfdTCP,SOL_SOCKET,SO_REUSEADDR,&timeout_t,sizeof(timeout_t)) == -1 )
	{
		perror("setsockopt error");
		return NULL;
	}	//hunbuso
	
	if (bind(sockfdTCP, (struct sockaddr * ) &me, sizeof(me)) == -1) {
		perror("bind error");
		close(sockfdTCP);
		return NULL;
	}
	
	if (listen(sockfdTCP, 1) == -1) {
		perror("listen error");
		close(sockfdTCP);
		return NULL;
	}
	
	while (1) {
		addrlen = sizeof(cliaddr);
		if ((sockfd = accept(sockfdTCP, &cliaddr, &addrlen)) == -1) {
			perror("accept error");
			close(sockfdTCP);
			return NULL;
		}
		
		memset(TCPtemp, 0, 1449);
		

		if (args->fileattr[FileID] == IPMSG_FILE_REGULAR) {	/*传送的是文件*/
			i = 0;
			while (1) {
				memset(TCPsendbuf, 0, 1449);
				if ( (numbytes = recv(sockfd, TCPsendbuf, 1448, 0)) == -1) {
					perror("recv error");
					close(sockfdTCP);
					return NULL;
				}
				strncat(TCPtemp, TCPsendbuf, sizeof(TCPtemp));
				t = strchr(TCPtemp, ':');
				i = 1;
				while (t) {
					tt = t;
					t = strchr(t + 1, ':');
					i++;
				}
				if (i == 9) {
					if ( *(tt + 1) == '\0') {
						break;
					}
				}
			}
			ipmsgswitch( & data, TCPtemp);	
			printf("file\n");
			if (recvflag) {	/*收到返回信息，开始发送文件*/
				if (startsendflag == 1) {
					if (FileID > args->filenum - 1 || FileID < 0) {
					printf("There is no this file\n");
					startsendflag = 0;
						close(sockfdTCP);
						return NULL;	
					}
					if ( (fp = fopen(LOCALE_FROM_UTF8(args->filename[FileID]), "r")) == NULL) {
						perror("fopen");
						close(sockfdTCP);
						return NULL;
					}
					while (1) {
						if ( (numbytes = fread(TCPsendbuf, sizeof(char), 1448, fp)) < 1448) {
							if (ferror(fp)) {
								perror("fread");
								close(sockfdTCP);
								fclose(fp);
								return NULL;
							}
						}
						if (send(sockfd, TCPsendbuf, numbytes, 0) == -1) {
							perror("send");
							fclose(fp);
							close(sockfdTCP);
							return NULL;
						}
						if (feof(fp))
							break;
					}
					startsendflag = 0;
					fclose(fp);
				}
			}
		}
		else {			/*传送的是文件夹*/
			i = 0;
			while (1) {
				memset(TCPsendbuf, 0, 1449);
				if ( (numbytes = recv(sockfd, TCPsendbuf, 1448, 0)) == -1) {
					perror("recv error");
					close(sockfdTCP);
					return NULL;
				}
				strncat(TCPtemp, TCPsendbuf, sizeof(TCPtemp));
				t = strchr(TCPtemp, ':');
				i = 1;
				while (t) {
					tt = t;
					t = strchr(t + 1, ':');
					i++;
				}
				if (i == 8) {
					if ( *(tt + 1) == '\0') {
						break;
					}
				}
			}
			ipmsgswitch( & data, TCPtemp);	
			if (recvflag) {
				if (startsendflag) {
					if (FileID > args->filenum -1 || FileID < 0) {
						printf("There is no this directory\n");
						startsendflag = 0;
						close(sockfdTCP);
						return NULL;
					}
					if(senddir(args->filename[FileID], sockfd) == 0) {
						close(sockfdTCP);
						startsendflag = 0;
						return NULL;
					}
					close(sockfdTCP);
					startsendflag = 0;
				}
			}
		}
		sendfilenum--;
		if(sendfilenum == 0)
			break;
	}
	printf("translate finished\n");
	close(sockfdTCP);
	if (malloc_flag) {
		free(p);
	}
	free(args);
#endif
	return NULL;
 }
 
 int senddir(char dir[], int socksendfd)
 {
	struct dirent	nextdp;
	struct dirent	*q = NULL;
	int 		re;
	stack		*head = NULL;
	stack		*tail = NULL;
	stack		*p = NULL;
	char		path[PATH_MAX + 1] = {'\0'};
	struct stat	buf;
	char		*pp = NULL;
	char		*t = NULL;
	int		depth = 0;
	char		TCPsendbuf[65536] = {'\0'};
	char		TCPsend[1449] = {'\0'};
	char		temp[5] = {'\0'};
	FILE		*fp = NULL;
	int		numbytes;
	char		filename_temp[PATH_MAX + 1];
	
	head = (stack *)malloc(sizeof(stack));
	tail = head;
	head->next = NULL;
	head->pre = NULL;
	head->dp = opendir(dir);
	depth++;
	strncpy(path, dir, PATH_MAX + 1);
	if (lstat(path, &buf) < 0) {
		perror("lstat error");
		return 0;
	}
	
	strncpy(filename_temp, dir, PATH_MAX + 1);
	t = strrchr(filename_temp, '/');
	if (t && (*(t + 1) == '\0')) {
		*t = '\0';
		t = strrchr(filename_temp, '/');
		memmove(filename_temp, t + 1, strlen(t + 1) + 1);
	}
	else if (t && ( *(t + 1) != '\0'))
		memmove(filename_temp, t + 1, strlen(t + 1) + 1);
	
	pp = strchr(filename_temp, ':');
	if (pp != NULL) {
		strncpy(&TCPsendbuf[4], filename_temp, pp - filename_temp);
		TCPsendbuf[4 + strlen(&TCPsendbuf[4])] = ':';
		strncpy(&TCPsendbuf[4 + strlen(&TCPsendbuf[4]) + 1], pp + 1, strlen(pp + 1) +1);
		snprintf(&TCPsendbuf[4 + strlen(&TCPsendbuf[4])], 65535, ":%09lx:%lx:%lx=%lx:%lx=%lx:", \
				0UL, IPMSG_FILE_DIR, IPMSG_FILE_MTIME, buf.st_mtime, IPMSG_FILE_CREATETIME, buf.st_ctime);
	}
	else {
		snprintf(&TCPsendbuf[4], 65535, ":%s:%09lx:%lx:%lx=%lx:%lx=%lx:", filename_temp, \
				0UL, IPMSG_FILE_DIR, IPMSG_FILE_MTIME, buf.st_mtime, IPMSG_FILE_CREATETIME, buf.st_ctime);
	}
	
	head->ctime = buf.st_ctime;
	head->mtime = buf.st_mtime;
	snprintf(temp, 5, "%04x", strlen(&TCPsendbuf[4]) + 4);
	strncpy(TCPsendbuf, temp, 4);
	pp = strrchr(path, '/');
	if ( pp && *(pp + 1) != '\0') {
		path[strlen(path) + 1] = '\0';
		path[strlen(path)] = '/';
	}
	if (!pp) {
		path[strlen(path) + 1] = '\0';
		path[strlen(path)] = '/';
	}
	
	if (send(socksendfd, TCPsendbuf, strlen(TCPsendbuf), 0) == -1) {
		perror("send error1");
		return 0;
	}
	memset(TCPsendbuf, 0, strlen(TCPsendbuf));
	
	while (1) {
		re = readdir_r(tail->dp, &nextdp, &q);
		if (re) {
			perror("readdir_r error");
			break;
		}
		
		if (q == NULL) {
			snprintf(&TCPsendbuf[4], 65535, ":%s:%x:%lx:%lx=%lx:%lx=%lx:", ".", 0, \
					IPMSG_FILE_RETPARENT, IPMSG_FILE_MTIME, \
					tail->mtime, IPMSG_FILE_CREATETIME, tail->ctime);
			snprintf(temp, 5, "%04x", strlen(&TCPsendbuf[4]) + 4);
			strncpy(TCPsendbuf, temp, 4);
			if (send(socksendfd, TCPsendbuf, strlen(TCPsendbuf), 0) == -1) {
				perror("send error2");
				return 0;
			}
			memset(TCPsendbuf, 0, strlen(TCPsendbuf));
			
			pp = strrchr(path, '/');
			if (pp == NULL) {
				closedir(tail->dp);
				break;
			}
			if ( *(pp + 1) == '\0') {
				*pp = '\0';
				pp = strrchr(path, '/');
			}
			if (pp != NULL)
				*(pp + 1) = '\0';
			closedir(tail->dp);
			POP(tail);
			depth--;
			if (depth == 0) break;
			else continue;
		}
		
		if (strcmp(nextdp.d_name, ".") && strcmp(nextdp.d_name, "..")) {
			strncat(path, nextdp.d_name, strlen(nextdp.d_name) + 1);
			printf("%s\n", path);
			if (lstat(path, &buf) < 0) {
				perror("lstat");
			}
			if (S_ISDIR(buf.st_mode)) {
				pp = strchr(nextdp.d_name, ':');
				if (pp != NULL) {
					strncpy(&TCPsendbuf[4], nextdp.d_name, pp - path);
					TCPsendbuf[4 + strlen(&TCPsendbuf[4])] = ':';
					strncpy(&TCPsendbuf[4 + strlen(&TCPsendbuf[4]) + 1], pp + 1, strlen(pp + 1) +1);
					snprintf(&TCPsendbuf[4 + strlen(&TCPsendbuf[4])], 65535, \
							":%09lx:%lx:%lx=%lx:%lx=%lx:",0LU, IPMSG_FILE_DIR, \
							IPMSG_FILE_MTIME, buf.st_mtime, \
							IPMSG_FILE_CREATETIME, buf.st_ctime);
				}
				else {
					snprintf(&TCPsendbuf[4], 65535, ":%s:%09lx:%lx:%lx=%lx:%lx=%lx:", \
							nextdp.d_name, 0LU, \
							IPMSG_FILE_DIR, IPMSG_FILE_MTIME, buf.st_mtime, \
							IPMSG_FILE_CREATETIME, buf.st_ctime);
				}
				snprintf(temp, 5, "%04x", strlen(&TCPsendbuf[4]) + 4);
				strncpy(TCPsendbuf, temp, 4);
				if (send(socksendfd, TCPsendbuf, strlen(TCPsendbuf), 0) == -1) {
					perror("send error3");
					return 0;
				}
				memset(TCPsendbuf, 0, strlen(TCPsendbuf));
				
				path[strlen(path) + 1] = '\0';
				path[strlen(path)] = '/';
				p = (stack *)malloc(sizeof(stack));
				p->next = NULL;
				p->pre = NULL;
				p->dp = opendir(path);
				p->ctime = buf.st_ctime;
				p->mtime = buf.st_mtime;
				PUSH(p);
				depth++;
			}
			else {
				pp = strchr(nextdp.d_name, ':');
				if (pp != NULL) {
					strncpy(&TCPsendbuf[4], nextdp.d_name, pp - path);
					TCPsendbuf[4 + strlen(&TCPsendbuf[4])] = ':';
					strncpy(&TCPsendbuf[4 + strlen(&TCPsendbuf[4]) + 1], pp + 1, strlen(pp + 1) +1);
					snprintf(&TCPsendbuf[4 + strlen(&TCPsendbuf[4])], 65535, \
							":%09lx:%lx:%lx=%lx:%lx=%lx",buf.st_size, IPMSG_FILE_REGULAR, \
							IPMSG_FILE_MTIME, buf.st_mtime, IPMSG_FILE_CREATETIME, \
							buf.st_ctime);
				}
				else {
					snprintf(&TCPsendbuf[4], 65535, ":%s:%09lx:%lx:%lx=%lx:%lx=%lx", nextdp.d_name, \
							buf.st_size, IPMSG_FILE_REGULAR, IPMSG_FILE_MTIME, buf.st_mtime, \
							IPMSG_FILE_CREATETIME, buf.st_ctime);
				}
				snprintf(temp, 5, "%04x", strlen(&TCPsendbuf[4]) + 4);
				strncpy(TCPsendbuf, temp, 4);
				if (send(socksendfd, TCPsendbuf, strlen(TCPsendbuf), 0) == -1) {
					perror("send error4");
					return 0;
				}
				memset(TCPsendbuf, 0, strlen(TCPsendbuf));
				if ((fp = fopen(path, "r")) == NULL) {
					perror("fopen error");
					return 0;
				}
				while (1) {
					if ( (numbytes = fread(TCPsend, sizeof(char), 1448, fp)) < 1448) {
						if (ferror(fp)) {
							perror("fread");
							fclose(fp);
							return 0;
						}
					}
					if (send(socksendfd, TCPsend, numbytes, 0) == -1) {
						perror("send error5");
						fclose(fp);
						return 0;
					}
					if (feof(fp))
						break;
				}
				fclose(fp);
				path[strlen(path)] = '\0';
				pp = strrchr(path, '/');
				if ( *(pp + 1) == '\0') {
					*pp = '\0';
					pp = strrchr(path, '/');
				}
				*(pp + 1) = '\0';
			}
		}
	}

	return 1;
 }
 
 void	* getfiles( void * arg )
 {
	char 			buf[1449] = {'\0'};
	char 			* t = NULL;
	char 			* t2 = NULL;
	char  			temp[65536] = {'\0'};
	FILE 			* fp = NULL;
	int 			numbytes = 0;
	unsigned long long 	offset = 0;
	time_t 			now;
	unsigned int 		last_time;
	int 			len;
	struct utimbuf 		timebuf;
	transfolderheader 	folder;
	char 			buf_path[PATH_MAX];
	unsigned int 		header_len;
	unsigned long long 	buf_size;
	int 			buf_fileattr;
	time_t 			buf_mtime;
	time_t 			buf_ctime;
	char 			flag = 0;
	char 			fpflag = 0;
	char 			pocketEOFflag = 0;
	char 			* pointer = NULL;
	int 			depth = 0;
	int 			step;
	char 			* buf_offset = NULL;

	/*设置本线程的状态为接收到cancel信号后取消本线程*/
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
	
	memset(folder.filename, 0, PATH_MAX);
	
	if( (trans_file_socs[0] = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		fprintf(stderr, "Socket error:%s\n\a", strerror(errno)); 
		exit(1); 
	}
	
	if(connect(trans_file_socs[0], (struct sockaddr *) ( &trans_file_from[0]), sizeof(struct sockaddr)) == -1) { 
		fprintf(stderr, "Connect Error:%s\a\n", strerror(errno)); 
		exit(1); 
	}
	
	now = time(NULL);
	last_time = 0;
	memset(buffer, 0, MAXSOCKBUF);
	if ( (unsigned int) now <= last_time)	
		now = ++last_time;
	last_time = now;
	
	if (files[filenum - 1].fileattr == 1) {		
/*		
		snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%lu:%x:%x:%x:", \
				(unsigned int ) now, user, hostname, IPMSG_GETFILEDATA, \
				( (ipmsgdata *) arg)->packetno, (unsigned int ) (files[filenum-1].fileID), \
				(unsigned int ) offset);
*/
		snprintf(buffer, sizeof(buffer), "1:%u:%s:%s:%lu:%x:%x:%x:", \
				(unsigned int ) now, user, hostname, IPMSG_GETFILEDATA, \
				pocketnos_get, (unsigned int ) (files[filenum-1].fileID), \
				(unsigned int ) offset);
	}
	else if (files[filenum - 1].fileattr == 2) {
		snprintf(buffer,sizeof(buffer), "1:%u:%s:%s:%lu:%x:%x:", \
				(unsigned int ) now, user, hostname, IPMSG_GETDIRFILES, \
				pocketnos_get, files[filenum-1].fileID);
	}
	
	len = strlen(buffer) + 1;
	
	if (files[filenum-1].fileattr == IPMSG_FILE_REGULAR) {
		
		depth = 0;
	while (1) {
			if( (access(path_save_files, 0) == 0) && (writeflag == 0) ) {				
//				printf("The filename already exsits.Do you want to replace it?[Y/N]\n");
				if( !dialog_overwrite_file_confirm ){
				gdk_threads_enter();			
				dialog_overwrite_file_confirm = create_dialog_overwrite_file_confirm();
				gtk_widget_show_all(dialog_overwrite_file_confirm);				
				gdk_threads_leave();	
				}
			sleep(1);				
			}
			else if( (access(path_save_files, 0) == 0) && (writeflag == 1) ) {
				break;
			}
			else 
				break;
	}
	
	if( filechooserdialog_save_files ) {
		gdk_threads_enter();
		gtk_widget_destroy(filechooserdialog_save_files);
		filechooserdialog_save_files = NULL;
		gdk_threads_leave();
	}
	if( win_get_files ) {
		gdk_threads_enter();
		gtk_widget_destroy(win_get_files);
		win_get_files = NULL;
		gdk_threads_leave();
	}
	
		if ( (fp = fopen(path_save_files, "wb")) == NULL) {
			perror("fopen error");
			exit(1);
		}
		
		offset = 0;
		
		send(trans_file_socs[0], buffer, len, 0);
		
		while (1){
			
			if ( (numbytes = recv(trans_file_socs[0], buf, 1448, 0)) == -1){		
				perror("recv error");
				exit(1);
			}
			
			offset += numbytes;
			fwrite(buf, 1, numbytes, fp);
			
			if(offset == files[filenum - 1].size)
				break;
		}
		
		fclose(fp);
		timebuf.modtime = (time_t ) files[filenum - 1].mtime;
		if(utime(path_save_files, & timebuf) == -1) {
			perror("utime");
			exit(1);
		}
		
	}
	else if (files[filenum - 1].fileattr == IPMSG_FILE_DIR){
		//此处写创建目录并接收文件夹的代码
		depth++;
		offset = 0;
		step = 1;
		
		while (1) {
			if (!pocketEOFflag) {
				if( (numbytes = recv(trans_file_socs[0], buf, 1448, 0)) == -1) {
					perror("recv error");
					exit(1);
				}
				
				pocketEOFflag = 1;
				pointer = buf;
			}
			
			if (!flag) {
				flag = 1;
				step = strlen(temp);
				strcat(temp, pointer);
				
				if (strlen(temp) < 4) {
					pocketEOFflag = 0;
					flag = 0;
					continue;
				}
				else
					sscanf(temp, "%x", & header_len);
				
				if (strlen(temp) < header_len) {
					pocketEOFflag = 0;
					flag = 0;
					continue;
				}
				
				buf_offset = pointer + abs(header_len - step);
				t = strchr(temp, ':');
				t2 = strchr(t + 1, ':');
				if (t2 == t +1)
					memmove(t2, t2 + 1, strlen(t2 + 1));
				
				strncpy(buf_path, t + 1, t2 - t - 1);
				sscanf(t2+1, "%llx", & buf_size);
				t2 = strchr(t2 + 1, ':');
				sscanf(t2 + 1, "%x", & buf_fileattr);
				t2 = strchr(t2 + 1, ':');
				sscanf(t2 + 1, "%x", & len);
				
				if (len == IPMSG_FILE_MTIME) {
					t2 = strchr(t2 + 1, '=');
					sscanf(t2 + 1, "%lx", & buf_mtime);
				}
				
				t2 = strchr(t2 + 1, ':');
				sscanf(t2 + 1, "%x", & len);
				pointer = buf_offset;
				
				if (len == IPMSG_FILE_CREATETIME) {
					t2 = strchr(t2 + 1, '=');
					sscanf(t2 + 1, "%lx", & buf_ctime);
				}
				
				offset = 0;
				memset(temp, 0, 1449);
			}
			
			if ( (pointer - buf) == numbytes) {
				pocketEOFflag = 0;
				pointer = buf;
				if (buf_fileattr != IPMSG_FILE_RETPARENT)
					continue;
			}
			
			if (buf_fileattr == IPMSG_FILE_REGULAR) {	/*接收到的是文件夹中的文件*/
				if (!fpflag) {
					folder.headersize = header_len;
					strcat(folder.filename, buf_path);
					folder.filesize = buf_size;
					folder.fileattr = buf_fileattr;
					folder.filemtime = buf_mtime;
					folder.filectime = buf_ctime;
					
					printf("%s\n", folder.filename);
					
					if( (fp = fopen(folder.filename, "wb")) == NULL) {
						printf("flag = %d\n", flag);
						perror("fopen");
						exit(1);
					}
					fpflag = 1;
				}
				
				if ( (numbytes - (pointer - buf)) >= (folder.filesize - offset)) {	/*如果在接收的一个包中剩余字节数大于文件的长度*/
					fwrite(pointer, 1, (folder.filesize - offset), fp);
					pointer += folder.filesize - offset;
					flag = 0;
					fclose(fp);
					header_len = 0;
					fpflag = 0;
					t = strrchr(folder.filename, '/');
					t += 1;
					* t = '\0';
					memset(t, 0, strlen(buf_path));
					memset(buf_path, 0, strlen(buf_path));
					offset += folder.filesize - offset;
				}
				else {
					fwrite(pointer, 1, numbytes - (pointer - buf), fp);
					offset += numbytes - (pointer - buf);
					pointer += numbytes - (pointer - buf);
				}
			}
			else if (buf_fileattr == IPMSG_FILE_DIR) {	/*接收到的是文件夹中的文件夹*/
				folder.headersize = header_len;
				strcat(folder.filename, buf_path);
				strcat(folder.filename, "/");
				folder.filesize = buf_size;
				folder.fileattr = buf_fileattr;
				folder.filemtime = buf_mtime;
				folder.filectime = buf_ctime;
				
				printf("%s\n", folder.filename);
				
				if( mkdir(folder.filename, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH |S_IXOTH) == -1) {
					perror("mkdir");
					exit(1);
				}
				
				depth++;
				flag = 0;
				memset(buf_path, 0, strlen(buf_path));
				header_len = 0;
			}
			else if (buf_fileattr == IPMSG_FILE_RETPARENT) {	/*文件夹结束*/
				
				depth--;
				
				if (depth == 1)
					break;
				t = strrchr(folder.filename, '/');
				* t = '\0';
				t2 = strrchr(folder.filename, '/');
				memset(t2 + 1, 0, t - t2);
				flag = 0;
				header_len = 0;
			}
			if ( (pointer - buf) == numbytes) {
				pocketEOFflag = 0;
				pointer = buf;
			}
		}
	}
	close(trans_file_socs[0]);
	return NULL;
 }
 
 /********************************************************************/
 void show_status( char *message_status)
 {	/*状态栏显示*/
	statusbar_main = lookup_widget(win_main, "statusbar_main");
	gtk_statusbar_push(GTK_STATUSBAR(statusbar_main), 0, message_status);
 }
 
 void show_error( char *message_error )
 {	/*出错警告对话框*/
	GtkWidget *win_message_box;
	GtkWidget *label_message_box;
	win_message_box = create_win_message_box();
	label_message_box = lookup_widget(win_message_box, "label_message_box");
	gtk_label_set_text(GTK_LABEL(label_message_box), message_error);
	gtk_widget_show_all(win_message_box);
	printf("Warning:%s\n",g_locale_from_utf8(message_error, strlen(message_error), NULL, NULL, NULL));	 
 }
