/***************************************************************************
 *            functions.h
 *
 *  Mon Apr  9 21:03:41 2007
 *  Copyright  2007  hunbuso
 *  hunbuso@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _FUNCTIONS_H
#define _FUNCTIONS_H

#ifdef __cplusplus
extern "C"
{
#endif

/*****************************Include Files**************************************/
	
#include	<pthread.h>
#include 	<stdio.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	<sys/types.h>
#include 	<sys/socket.h>
#include 	<sys/stat.h>
#include 	<errno.h>
#include 	<unistd.h>
#include 	<time.h>
#include 	<utime.h>
#include 	<netinet/in.h>
#include	<netdb.h>
#include 	<arpa/inet.h>
#include 	<pthread.h>
#include 	<limits.h>
#include 	<math.h>
#include	<signal.h>
#include 	<fcntl.h>
#include 	<sys/ioctl.h>
#include	<dirent.h>
#include	<gtk/gtk.h>
	
#include "ipmsg.h"
#include "message.h"
#include "support.h"
/*****************************   Macro   **************************************/

#define 	MAX_USER_NAME_LENGTH 	256
#define 	MAX_USER_GROUP_LENGTH 	256
#define 	HOSTNAME_LENGTH 	256
#define		MAX_FILE_NAME		256
#define 	MAXSOCKBUF 		8192
#define 	DEFAULTPORT 		2425
#define 	MAXTRANSFILENUM		100
#define 	MAXFILESEND		20
#define 	MAXREPEATTIME		3	/*最长的等待时间*/
#define		MAXCOMMANDLINELEN	100	/*输入命令的总长度*/
#define		MAX_APPEND_LEN		8192	/*附加区域的最大长度*/
#define		MAX_SEND_FILE_HEADER_LEN 0xffff	/*发送文件的头部的最大长度*/

#define	GB2312_FROM_UTF8(STRING)	g_convert(STRING, -1, "GB2312", "UTF-8", NULL, NULL, NULL)	
#define UTF8_FROM_GB2312(STRING)	g_convert(STRING, -1, "UTF-8", "GB2312", NULL, NULL, NULL)

#define LOCALE_FROM_UTF8(STRING)	g_locale_from_utf8(STRING, strlen(STRING), NULL, NULL, NULL)
#define UTF8_FROM_LOCALE(STRING)	g_locale_to_utf8(STRING, strlen(STRING), NULL, NULL, NULL)

#define FILENAME_FROM_UTF8(STRING)	g_filename_from_utf8(STRING, -1, NULL, NULL, NULL)
#define FILENAME_TO_UTF8(STRING)		g_filename_to_utf8(STRING, -1, NULL, NULL, NULL)

#define PUSH(p)		{((p)->pre) = tail; tail->next = (p); tail = tail->next;}
#define POP(tail)	{p = (tail); (tail) = (tail)->pre; if ((tail) != NULL) (tail)->next = NULL; free(p);}

/*******************************  Struct  **************************************/

typedef struct ipmsguser
{
	int 			user_num;	
	struct sockaddr_in 	user_addr;
	char 			user_name[MAX_USER_NAME_LENGTH];
	char 			user_group[MAX_USER_GROUP_LENGTH];
	char 			user_machine[HOSTNAME_LENGTH];
	char 			append[MAXSOCKBUF];
	char 			user_nick[MAX_USER_NAME_LENGTH];
	struct ipmsguser 	* next;
	struct ipmsguser 	* pre;
	
}ipmsg_user_list;

typedef struct ipmsgdata
{
	int 		version;
	unsigned int 	packetno;
	char 		sendername[MAX_USER_NAME_LENGTH];
	char		*ip;
	char 		senderhost[HOSTNAME_LENGTH];
	unsigned int 	com;
	char 		append[MAX_APPEND_LEN];
	char 		sendfileheader[MAX_SEND_FILE_HEADER_LEN];
}ipmsgdata;

typedef struct transfileheader
{
	unsigned int 		fileID;
	char 			filename[PATH_MAX];
	unsigned long long 	size;
	unsigned int 		mtime;
	unsigned long 		fileattr;
}transfileheader;

typedef struct transfolderheader
{
	int 			headersize;
	char 			filename[PATH_MAX];
	unsigned long long 	filesize;
	unsigned long 		fileattr;
	time_t 			filemtime;	//文件/文件夹的修改和创建时间
	time_t 			filectime;
}transfolderheader;

typedef struct sendfilearg
{
	int		filenum;
	int 		flags;	/*flags用来记录发送到的目的地的形式：1为序号，2为all，3为IP,4为用户名*/
	char 		filename[MAXFILESEND][PATH_MAX];	//文件/文件夹名
	unsigned long	fileattr[MAXFILESEND];	/*发送的文件的属性，为标志量，
						 *为0时表示对应的文件名为文件，为1表示对应为目录*/
	char 		to[20];	//目的地
}sendfilearg;

typedef struct stack
{
	DIR		*dp;
	time_t		ctime;
	time_t		mtime;
	struct stack	*next;
	struct stack	*pre;
}stack;

/******************************* Extern Var ***********************************/

extern int soc;
extern int ipmsgport;
extern int filenum;
extern int sendcheckflag;
extern int repeatflag;
extern int recvflag;
extern int startsendflag;
extern int arrivetimeflag;
extern int FileID;
extern int writeflag;
extern int trans_file_socs[8];
extern unsigned int pocketnos;
extern unsigned int pocketnos_get;
extern socklen_t fromlen;
extern char *user;
extern char *group;
extern char hostname[HOSTNAME_LENGTH];
extern char path_save_files[MAX_FILE_NAME];
extern char bcastaddrstr[];
extern char buff[8192];
extern char buffer[MAXSOCKBUF*2];

extern pthread_t	id;
extern pthread_t	id_sendfiles;
extern pthread_t	id_getfiles;

extern struct ipmsguser *head, *tail;	
extern struct sockaddr_in	me;
extern struct sockaddr_in	me_tcp;
extern struct sockaddr_in	bcast;
extern struct sockaddr_in	from;
extern struct sockaddr_in	trans_file_from[8];	
extern struct transfileheader	files[MAXTRANSFILENUM];
extern struct ipmsgdata		*datafortcp;
extern struct ipmsgdata		*data_rev;
extern struct sendfilearg	*arg;



/******************************   Functions   ***********************************/

void * watch_net(void *arg);
void ipmsgsendbcast(struct sockaddr_in * dest, unsigned int com, ipmsgdata * data);
void ipmsgswitch(ipmsgdata * data, char * buff);
void * sendfiles(void * arg);
void * getfiles(void * arg);
void show_status( char *message_status);
void show_error(char *message_error);
char user_exist(struct sockaddr_in * useraddr, ipmsgdata * data);
void del_user(struct sockaddr_in * useraddr, ipmsgdata * data);
void del_all_user(void);
int senddir(char dir[], int socksendfd);
ipmsg_user_list * search_user(unsigned int *usernum,struct in_addr *useraddr,char *username);
ipmsg_user_list * adduser(struct sockaddr_in * useraddrs, struct ipmsguser * q, ipmsgdata * data);
	
#ifdef __cplusplus
}
#endif

#endif /* _FUNCTIONS_H */
