#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_win_main (void)
{
  GtkWidget *win_main;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *label1;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist_machine;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *vbox3;
  GtkWidget *label12;
  GtkWidget *label6;
  GtkWidget *label_num_online;
  GtkWidget *button_refresh;
  GtkWidget *alignment3;
  GtkWidget *hbox6;
  GtkWidget *image9;
  GtkWidget *label22;
  GtkWidget *hseparator1;
  GtkWidget *scrolledwindow2;
  GtkWidget *textview_message;
  GtkWidget *hbuttonbox1;
  GtkWidget *button_send_message;
  GtkWidget *alignment2;
  GtkWidget *hbox5;
  GtkWidget *image8;
  GtkWidget *label21;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *statusbar_main;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  win_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (win_main, 460, 500);
  gtk_container_set_border_width (GTK_CONTAINER (win_main), 10);
  gtk_window_set_title (GTK_WINDOW (win_main), _("CugbIpMsg-gtk"));
  gtk_window_set_position (GTK_WINDOW (win_main), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (win_main), 400, 500);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (win_main), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hbox1, -1, 250);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (vbox2, 261, -1);

  label1 = gtk_label_new (_("\344\270\273\346\234\272\345\220\215"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox2), label1, FALSE, FALSE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_SHADOW_IN);

  clist_machine = gtk_clist_new (3);
  gtk_widget_show (clist_machine);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist_machine);
  gtk_container_set_border_width (GTK_CONTAINER (clist_machine), 3);
  gtk_clist_set_column_width (GTK_CLIST (clist_machine), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_machine), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_machine), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist_machine));

  label18 = gtk_label_new (_("\347\224\250\346\210\267\345\220\215"));
  gtk_widget_show (label18);
  gtk_clist_set_column_widget (GTK_CLIST (clist_machine), 0, label18);

  label19 = gtk_label_new (_("\344\270\273\346\234\272\345\220\215"));
  gtk_widget_show (label19);
  gtk_clist_set_column_widget (GTK_CLIST (clist_machine), 1, label19);

  label20 = gtk_label_new (_("IP\345\234\260\345\235\200"));
  gtk_widget_show (label20);
  gtk_clist_set_column_widget (GTK_CLIST (clist_machine), 2, label20);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox3, TRUE, FALSE, 0);

  label12 = gtk_label_new ("");
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (vbox3), label12, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label12, -1, 61);

  label6 = gtk_label_new (_("\345\234\250\347\272\277\347\224\250\346\210\267"));
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (vbox3), label6, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label6, -1, 42);

  label_num_online = gtk_label_new (_("0"));
  gtk_widget_show (label_num_online);
  gtk_box_pack_start (GTK_BOX (vbox3), label_num_online, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label_num_online, -1, 95);

  button_refresh = gtk_button_new ();
  gtk_widget_show (button_refresh);
  gtk_box_pack_start (GTK_BOX (vbox3), button_refresh, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, button_refresh, _("\345\210\267\346\226\260\345\234\250\347\272\277\347\232\204\344\272\272\346\225\260\345\222\214\344\270\273\346\234\272\345\210\227\350\241\250"), NULL);

  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (button_refresh), alignment3);

  hbox6 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox6);

  image9 = gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox6), image9, FALSE, FALSE, 0);

  label22 = gtk_label_new_with_mnemonic (_("\345\210\267\346\226\260"));
  gtk_widget_show (label22);
  gtk_box_pack_start (GTK_BOX (hbox6), label22, FALSE, FALSE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator1, -1, 15);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow2, FALSE, FALSE, 0);
  gtk_widget_set_size_request (scrolledwindow2, -1, 135);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_SHADOW_IN);

  textview_message = gtk_text_view_new ();
  gtk_widget_show (textview_message);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), textview_message);
  gtk_tooltips_set_tip (tooltips, textview_message, _("\345\234\250\350\277\231\344\270\252\350\276\223\345\205\245\344\275\240\346\203\263\345\217\221\351\200\201\347\232\204\346\266\210\346\201\257\357\274\214\347\204\266\345\220\216\346\214\211\342\200\234\345\217\221\351\200\201\346\266\210\346\201\257\342\200\235\346\214\211\351\222\256\350\277\233\350\241\214\345\217\221\351\200\201"), NULL);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textview_message), GTK_WRAP_WORD);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, TRUE, TRUE, 0);

  button_send_message = gtk_button_new ();
  gtk_widget_show (button_send_message);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_send_message);
  GTK_WIDGET_SET_FLAGS (button_send_message, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, button_send_message, _("\345\217\221\351\200\201\346\266\210\346\201\257 (\345\277\253\346\215\267\351\224\256Ctrl+Enter)"), NULL);
  gtk_widget_add_accelerator (button_send_message, "clicked", accel_group,
                              GDK_Return, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  alignment2 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment2);
  gtk_container_add (GTK_CONTAINER (button_send_message), alignment2);

  hbox5 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (alignment2), hbox5);

  image8 = gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image8);
  gtk_box_pack_start (GTK_BOX (hbox5), image8, FALSE, FALSE, 0);

  label21 = gtk_label_new_with_mnemonic (_("\345\217\221\351\200\201\346\266\210\346\201\257"));
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox5), label21, FALSE, FALSE, 0);

  button4 = gtk_button_new_with_mnemonic (_("\345\212\240\345\257\206"));
  gtk_widget_show (button4);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button4);
  gtk_widget_set_sensitive (button4, FALSE);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, button4, _("\345\212\240\345\257\206\344\274\240\351\200\201\347\232\204\346\266\210\346\201\257"), NULL);

  button5 = gtk_button_new_with_mnemonic (_("\350\246\201\346\261\202\345\233\236\345\244\215"));
  gtk_widget_show (button5);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button5);
  gtk_widget_set_sensitive (button5, FALSE);
  GTK_WIDGET_SET_FLAGS (button5, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, button5, _("\350\246\201\346\261\202\345\257\271\346\226\271\346\224\266\345\210\260\344\277\241\346\201\257\345\220\216\345\233\236\345\244\215\347\241\256\350\256\244\344\277\241\346\201\257"), NULL);

  statusbar_main = gtk_statusbar_new ();
  gtk_widget_show (statusbar_main);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar_main, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (statusbar_main), 3);

  g_signal_connect ((gpointer) win_main, "delete_event",
                    G_CALLBACK (on_win_main_delete_event),
                    NULL);
  g_signal_connect ((gpointer) clist_machine, "select_row",
                    G_CALLBACK (on_clist_machine_select_row),
                    NULL);
  g_signal_connect ((gpointer) clist_machine, "button_press_event",
                    G_CALLBACK (on_clist_machine_button_press_event),
                    NULL);
  g_signal_connect ((gpointer) button_refresh, "clicked",
                    G_CALLBACK (on_button_refresh_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_send_message, "clicked",
                    G_CALLBACK (on_button_send_message_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_main, win_main, "win_main");
  GLADE_HOOKUP_OBJECT (win_main, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (win_main, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (win_main, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (win_main, label1, "label1");
  GLADE_HOOKUP_OBJECT (win_main, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (win_main, clist_machine, "clist_machine");
  GLADE_HOOKUP_OBJECT (win_main, label18, "label18");
  GLADE_HOOKUP_OBJECT (win_main, label19, "label19");
  GLADE_HOOKUP_OBJECT (win_main, label20, "label20");
  GLADE_HOOKUP_OBJECT (win_main, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (win_main, label12, "label12");
  GLADE_HOOKUP_OBJECT (win_main, label6, "label6");
  GLADE_HOOKUP_OBJECT (win_main, label_num_online, "label_num_online");
  GLADE_HOOKUP_OBJECT (win_main, button_refresh, "button_refresh");
  GLADE_HOOKUP_OBJECT (win_main, alignment3, "alignment3");
  GLADE_HOOKUP_OBJECT (win_main, hbox6, "hbox6");
  GLADE_HOOKUP_OBJECT (win_main, image9, "image9");
  GLADE_HOOKUP_OBJECT (win_main, label22, "label22");
  GLADE_HOOKUP_OBJECT (win_main, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (win_main, scrolledwindow2, "scrolledwindow2");
  GLADE_HOOKUP_OBJECT (win_main, textview_message, "textview_message");
  GLADE_HOOKUP_OBJECT (win_main, hbuttonbox1, "hbuttonbox1");
  GLADE_HOOKUP_OBJECT (win_main, button_send_message, "button_send_message");
  GLADE_HOOKUP_OBJECT (win_main, alignment2, "alignment2");
  GLADE_HOOKUP_OBJECT (win_main, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (win_main, image8, "image8");
  GLADE_HOOKUP_OBJECT (win_main, label21, "label21");
  GLADE_HOOKUP_OBJECT (win_main, button4, "button4");
  GLADE_HOOKUP_OBJECT (win_main, button5, "button5");
  GLADE_HOOKUP_OBJECT (win_main, statusbar_main, "statusbar_main");
  GLADE_HOOKUP_OBJECT_NO_REF (win_main, tooltips, "tooltips");

  gtk_window_add_accel_group (GTK_WINDOW (win_main), accel_group);

  return win_main;
}

GtkWidget*
create_win_message_box (void)
{
  GtkWidget *win_message_box;
  GtkWidget *vbox4;
  GtkWidget *image10;
  GtkWidget *label_message_box;
  GtkWidget *hbox4;
  GtkWidget *button_message_OK;

  win_message_box = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (win_message_box, 340, 255);
  gtk_container_set_border_width (GTK_CONTAINER (win_message_box), 10);
  gtk_window_set_title (GTK_WINDOW (win_message_box), _("\350\255\246\345\221\212"));
  gtk_window_set_position (GTK_WINDOW (win_message_box), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_message_box), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (win_message_box), 57, -1);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (win_message_box), vbox4);

  image10 = gtk_image_new_from_stock ("gtk-dialog-warning", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image10);
  gtk_box_pack_start (GTK_BOX (vbox4), image10, TRUE, TRUE, 0);
  gtk_widget_set_size_request (image10, -1, 0);

  label_message_box = gtk_label_new ("");
  gtk_widget_show (label_message_box);
  gtk_box_pack_start (GTK_BOX (vbox4), label_message_box, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label_message_box, -1, 158);

  hbox4 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 5);

  button_message_OK = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button_message_OK);
  gtk_box_pack_start (GTK_BOX (hbox4), button_message_OK, FALSE, FALSE, 0);
  gtk_widget_set_size_request (button_message_OK, 70, -1);

  g_signal_connect ((gpointer) button_message_OK, "clicked",
                    G_CALLBACK (on_button_message_OK_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_message_box, win_message_box, "win_message_box");
  GLADE_HOOKUP_OBJECT (win_message_box, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (win_message_box, image10, "image10");
  GLADE_HOOKUP_OBJECT (win_message_box, label_message_box, "label_message_box");
  GLADE_HOOKUP_OBJECT (win_message_box, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (win_message_box, button_message_OK, "button_message_OK");

  return win_message_box;
}

GtkWidget*
create_menu_send (void)
{
  GtkWidget *menu_send;
  GtkWidget *sendfile;
  GtkWidget *image29;
  GtkWidget *del1;
  GtkWidget *sendfolder;
  GtkWidget *image30;
  GtkWidget *del2;
  GtkWidget *about;
  GtkWidget *image31;

  menu_send = gtk_menu_new ();
  gtk_container_set_border_width (GTK_CONTAINER (menu_send), 3);

  sendfile = gtk_image_menu_item_new_with_mnemonic (_("\344\274\240\351\200\201\346\226\207\344\273\266"));
  gtk_widget_show (sendfile);
  gtk_container_add (GTK_CONTAINER (menu_send), sendfile);

  image29 = gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image29);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (sendfile), image29);

  del1 = gtk_separator_menu_item_new ();
  gtk_widget_show (del1);
  gtk_container_add (GTK_CONTAINER (menu_send), del1);
  gtk_widget_set_sensitive (del1, FALSE);

  sendfolder = gtk_image_menu_item_new_with_mnemonic (_("\344\274\240\351\200\201\346\226\207\344\273\266\345\244\271"));
  gtk_widget_show (sendfolder);
  gtk_container_add (GTK_CONTAINER (menu_send), sendfolder);

  image30 = gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image30);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (sendfolder), image30);

  del2 = gtk_separator_menu_item_new ();
  gtk_widget_show (del2);
  gtk_container_add (GTK_CONTAINER (menu_send), del2);
  gtk_widget_set_sensitive (del2, FALSE);

  about = gtk_image_menu_item_new_with_mnemonic (_("\345\205\263\344\272\216"));
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (menu_send), about);

  image31 = gtk_image_new_from_stock ("gtk-info", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image31);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (about), image31);

  g_signal_connect ((gpointer) sendfile, "activate",
                    G_CALLBACK (on_sendfile_activate),
                    NULL);
  g_signal_connect ((gpointer) sendfolder, "activate",
                    G_CALLBACK (on_sendfolder_activate),
                    NULL);
  g_signal_connect ((gpointer) about, "activate",
                    G_CALLBACK (on_about_activate),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (menu_send, menu_send, "menu_send");
  GLADE_HOOKUP_OBJECT (menu_send, sendfile, "sendfile");
  GLADE_HOOKUP_OBJECT (menu_send, image29, "image29");
  GLADE_HOOKUP_OBJECT (menu_send, del1, "del1");
  GLADE_HOOKUP_OBJECT (menu_send, sendfolder, "sendfolder");
  GLADE_HOOKUP_OBJECT (menu_send, image30, "image30");
  GLADE_HOOKUP_OBJECT (menu_send, del2, "del2");
  GLADE_HOOKUP_OBJECT (menu_send, about, "about");
  GLADE_HOOKUP_OBJECT (menu_send, image31, "image31");

  return menu_send;
}

GtkWidget*
create_win_get_message (void)
{
  GtkWidget *win_get_message;
  GtkWidget *vbox5;
  GtkWidget *frame1;
  GtkWidget *alignment4;
  GtkWidget *vbox6;
  GtkWidget *label_user_machine;
  GtkWidget *label_time;
  GtkWidget *label23;
  GtkWidget *hseparator3;
  GtkWidget *scrolledwindow3;
  GtkWidget *textview_show_message;
  GtkWidget *hseparator2;
  GtkWidget *hbuttonbox2;
  GtkWidget *button_cancel;
  GtkWidget *alignment6;
  GtkWidget *hbox8;
  GtkWidget *image12;
  GtkWidget *label27;
  GtkWidget *button_reply;
  GtkWidget *alignment5;
  GtkWidget *hbox7;
  GtkWidget *image11;
  GtkWidget *label26;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  win_get_message = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (win_get_message, 328, 326);
  gtk_container_set_border_width (GTK_CONTAINER (win_get_message), 5);
  gtk_window_set_title (GTK_WINDOW (win_get_message), _("\346\216\245\346\224\266\345\210\260\346\266\210\346\201\257"));
  gtk_window_set_position (GTK_WINDOW (win_get_message), GTK_WIN_POS_CENTER);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (win_get_message), vbox5);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox5), frame1, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_NONE);

  alignment4 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment4);
  gtk_container_add (GTK_CONTAINER (frame1), alignment4);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment4), 0, 0, 12, 0);

  vbox6 = gtk_vbox_new (TRUE, 0);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (alignment4), vbox6);

  label_user_machine = gtk_label_new ("");
  gtk_widget_show (label_user_machine);
  gtk_box_pack_start (GTK_BOX (vbox6), label_user_machine, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label_user_machine), TRUE);

  label_time = gtk_label_new ("");
  gtk_widget_show (label_time);
  gtk_box_pack_start (GTK_BOX (vbox6), label_time, FALSE, FALSE, 0);

  label23 = gtk_label_new (_("<b>\346\266\210\346\201\257\346\235\245\350\207\252</b>"));
  gtk_widget_show (label23);
  gtk_frame_set_label_widget (GTK_FRAME (frame1), label23);
  gtk_label_set_use_markup (GTK_LABEL (label23), TRUE);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox5), hseparator3, TRUE, TRUE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (scrolledwindow3, -1, 130);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_SHADOW_IN);

  textview_show_message = gtk_text_view_new ();
  gtk_widget_show (textview_show_message);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), textview_show_message);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textview_show_message), GTK_WRAP_WORD);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox5), hseparator2, TRUE, TRUE, 0);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox5), hbuttonbox2, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_SPREAD);

  button_cancel = gtk_button_new ();
  gtk_widget_show (button_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), button_cancel);
  GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, button_cancel, _("\345\205\263\351\227\255\347\252\227\345\217\243"), NULL);

  alignment6 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment6);
  gtk_container_add (GTK_CONTAINER (button_cancel), alignment6);

  hbox8 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox8);
  gtk_container_add (GTK_CONTAINER (alignment6), hbox8);

  image12 = gtk_image_new_from_stock ("gtk-close", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image12);
  gtk_box_pack_start (GTK_BOX (hbox8), image12, FALSE, FALSE, 0);

  label27 = gtk_label_new_with_mnemonic (_("\345\205\263\351\227\255"));
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (hbox8), label27, FALSE, FALSE, 0);

  button_reply = gtk_button_new ();
  gtk_widget_show (button_reply);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), button_reply);
  GTK_WIDGET_SET_FLAGS (button_reply, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, button_reply, _("\345\233\236\345\244\215\346\266\210\346\201\257"), NULL);

  alignment5 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment5);
  gtk_container_add (GTK_CONTAINER (button_reply), alignment5);

  hbox7 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (alignment5), hbox7);

  image11 = gtk_image_new_from_stock ("gtk-go-back", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image11);
  gtk_box_pack_start (GTK_BOX (hbox7), image11, FALSE, FALSE, 0);

  label26 = gtk_label_new_with_mnemonic (_("\345\233\236\345\244\215"));
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox7), label26, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) win_get_message, "show",
                    G_CALLBACK (on_win_get_message_show),
                    NULL);
  g_signal_connect ((gpointer) button_cancel, "clicked",
                    G_CALLBACK (on_button_cancel_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_reply, "clicked",
                    G_CALLBACK (on_button_reply_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_get_message, win_get_message, "win_get_message");
  GLADE_HOOKUP_OBJECT (win_get_message, vbox5, "vbox5");
  GLADE_HOOKUP_OBJECT (win_get_message, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (win_get_message, alignment4, "alignment4");
  GLADE_HOOKUP_OBJECT (win_get_message, vbox6, "vbox6");
  GLADE_HOOKUP_OBJECT (win_get_message, label_user_machine, "label_user_machine");
  GLADE_HOOKUP_OBJECT (win_get_message, label_time, "label_time");
  GLADE_HOOKUP_OBJECT (win_get_message, label23, "label23");
  GLADE_HOOKUP_OBJECT (win_get_message, hseparator3, "hseparator3");
  GLADE_HOOKUP_OBJECT (win_get_message, scrolledwindow3, "scrolledwindow3");
  GLADE_HOOKUP_OBJECT (win_get_message, textview_show_message, "textview_show_message");
  GLADE_HOOKUP_OBJECT (win_get_message, hseparator2, "hseparator2");
  GLADE_HOOKUP_OBJECT (win_get_message, hbuttonbox2, "hbuttonbox2");
  GLADE_HOOKUP_OBJECT (win_get_message, button_cancel, "button_cancel");
  GLADE_HOOKUP_OBJECT (win_get_message, alignment6, "alignment6");
  GLADE_HOOKUP_OBJECT (win_get_message, hbox8, "hbox8");
  GLADE_HOOKUP_OBJECT (win_get_message, image12, "image12");
  GLADE_HOOKUP_OBJECT (win_get_message, label27, "label27");
  GLADE_HOOKUP_OBJECT (win_get_message, button_reply, "button_reply");
  GLADE_HOOKUP_OBJECT (win_get_message, alignment5, "alignment5");
  GLADE_HOOKUP_OBJECT (win_get_message, hbox7, "hbox7");
  GLADE_HOOKUP_OBJECT (win_get_message, image11, "image11");
  GLADE_HOOKUP_OBJECT (win_get_message, label26, "label26");
  GLADE_HOOKUP_OBJECT_NO_REF (win_get_message, tooltips, "tooltips");

  return win_get_message;
}

GtkWidget*
create_filechooserdialog_send (void)
{
  GtkWidget *filechooserdialog_send;
  GtkWidget *dialog_vbox1;
  GtkWidget *dialog_action_area1;
  GtkWidget *filechooser_button_cancel;
  GtkWidget *filechooser_button_open;

  filechooserdialog_send = gtk_file_chooser_dialog_new (_("\351\200\211\346\213\251\350\246\201\344\274\240\351\200\201\347\232\204\346\226\207\344\273\266"), NULL, GTK_FILE_CHOOSER_ACTION_OPEN, NULL);
  gtk_window_set_modal (GTK_WINDOW (filechooserdialog_send), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (filechooserdialog_send), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (filechooserdialog_send)->vbox;
  gtk_widget_show (dialog_vbox1);

  dialog_action_area1 = GTK_DIALOG (filechooserdialog_send)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  filechooser_button_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (filechooser_button_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog_send), filechooser_button_cancel, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (filechooser_button_cancel, GTK_CAN_DEFAULT);

  filechooser_button_open = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (filechooser_button_open);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog_send), filechooser_button_open, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (filechooser_button_open, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) filechooser_button_cancel, "clicked",
                    G_CALLBACK (on_filechooser_button_cancel_clicked),
                    NULL);
  g_signal_connect ((gpointer) filechooser_button_open, "clicked",
                    G_CALLBACK (on_filechooser_button_open_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_send, filechooserdialog_send, "filechooserdialog_send");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_send, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_send, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (filechooserdialog_send, filechooser_button_cancel, "filechooser_button_cancel");
  GLADE_HOOKUP_OBJECT (filechooserdialog_send, filechooser_button_open, "filechooser_button_open");

  gtk_widget_grab_default (filechooser_button_open);
  return filechooserdialog_send;
}

GtkWidget*
create_window_send_files (void)
{
  GtkWidget *window_send_files;
  GtkWidget *vbox7;
  GtkWidget *label28;
  GtkWidget *scrolledwindow4;
  GtkWidget *clist_file_selected;
  GtkWidget *label35;
  GtkWidget *label_file_num_total;
  GtkWidget *label_file_dest;
  GtkWidget *hseparator4;
  GtkWidget *hbuttonbox3;
  GtkWidget *button_win_send_confirm;
  GtkWidget *alignment7;
  GtkWidget *hbox9;
  GtkWidget *image13;
  GtkWidget *label36;
  GtkWidget *button_win_send_cancel;
  GtkWidget *alignment8;
  GtkWidget *hbox10;
  GtkWidget *image14;
  GtkWidget *label37;

  window_send_files = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (window_send_files, 424, 349);
  gtk_window_set_title (GTK_WINDOW (window_send_files), _("\344\274\240\351\200\201\346\226\207\344\273\266"));
  gtk_window_set_position (GTK_WINDOW (window_send_files), GTK_WIN_POS_CENTER);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (window_send_files), vbox7);
  gtk_container_set_border_width (GTK_CONTAINER (vbox7), 9);

  label28 = gtk_label_new (_("\344\273\245\344\270\213\346\226\207\344\273\266\345\260\206\350\242\253\344\274\240\351\200\201:"));
  gtk_widget_show (label28);
  gtk_box_pack_start (GTK_BOX (vbox7), label28, FALSE, FALSE, 0);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox7), scrolledwindow4, TRUE, TRUE, 0);
  gtk_widget_set_size_request (scrolledwindow4, -1, 180);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_SHADOW_IN);

  clist_file_selected = gtk_clist_new (1);
  gtk_widget_show (clist_file_selected);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), clist_file_selected);
  gtk_container_set_border_width (GTK_CONTAINER (clist_file_selected), 3);
  gtk_clist_set_column_width (GTK_CLIST (clist_file_selected), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clist_file_selected));

  label35 = gtk_label_new (_("label35"));
  gtk_widget_show (label35);
  gtk_clist_set_column_widget (GTK_CLIST (clist_file_selected), 0, label35);

  label_file_num_total = gtk_label_new ("");
  gtk_widget_show (label_file_num_total);
  gtk_box_pack_start (GTK_BOX (vbox7), label_file_num_total, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (label_file_num_total, GTK_CAN_FOCUS);
  gtk_label_set_justify (GTK_LABEL (label_file_num_total), GTK_JUSTIFY_CENTER);
  gtk_label_set_selectable (GTK_LABEL (label_file_num_total), TRUE);

  label_file_dest = gtk_label_new ("");
  gtk_widget_show (label_file_dest);
  gtk_box_pack_start (GTK_BOX (vbox7), label_file_dest, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (label_file_dest, GTK_CAN_FOCUS);
  gtk_label_set_justify (GTK_LABEL (label_file_dest), GTK_JUSTIFY_CENTER);
  gtk_label_set_selectable (GTK_LABEL (label_file_dest), TRUE);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox7), hseparator4, TRUE, TRUE, 0);

  hbuttonbox3 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox3);
  gtk_box_pack_start (GTK_BOX (vbox7), hbuttonbox3, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox3), GTK_BUTTONBOX_SPREAD);

  button_win_send_confirm = gtk_button_new ();
  gtk_widget_show (button_win_send_confirm);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), button_win_send_confirm);
  GTK_WIDGET_SET_FLAGS (button_win_send_confirm, GTK_CAN_DEFAULT);

  alignment7 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment7);
  gtk_container_add (GTK_CONTAINER (button_win_send_confirm), alignment7);

  hbox9 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER (alignment7), hbox9);

  image13 = gtk_image_new_from_stock ("gtk-spell-check", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image13);
  gtk_box_pack_start (GTK_BOX (hbox9), image13, FALSE, FALSE, 0);

  label36 = gtk_label_new_with_mnemonic (_("\347\241\256\350\256\244"));
  gtk_widget_show (label36);
  gtk_box_pack_start (GTK_BOX (hbox9), label36, FALSE, FALSE, 0);

  button_win_send_cancel = gtk_button_new ();
  gtk_widget_show (button_win_send_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), button_win_send_cancel);
  GTK_WIDGET_SET_FLAGS (button_win_send_cancel, GTK_CAN_DEFAULT);

  alignment8 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment8);
  gtk_container_add (GTK_CONTAINER (button_win_send_cancel), alignment8);

  hbox10 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (alignment8), hbox10);

  image14 = gtk_image_new_from_stock ("gtk-cancel", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image14);
  gtk_box_pack_start (GTK_BOX (hbox10), image14, FALSE, FALSE, 0);

  label37 = gtk_label_new_with_mnemonic (_("\345\217\226\346\266\210"));
  gtk_widget_show (label37);
  gtk_box_pack_start (GTK_BOX (hbox10), label37, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) button_win_send_confirm, "clicked",
                    G_CALLBACK (on_button_win_send_confirm_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_win_send_cancel, "clicked",
                    G_CALLBACK (on_button_win_send_cancel_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window_send_files, window_send_files, "window_send_files");
  GLADE_HOOKUP_OBJECT (window_send_files, vbox7, "vbox7");
  GLADE_HOOKUP_OBJECT (window_send_files, label28, "label28");
  GLADE_HOOKUP_OBJECT (window_send_files, scrolledwindow4, "scrolledwindow4");
  GLADE_HOOKUP_OBJECT (window_send_files, clist_file_selected, "clist_file_selected");
  GLADE_HOOKUP_OBJECT (window_send_files, label35, "label35");
  GLADE_HOOKUP_OBJECT (window_send_files, label_file_num_total, "label_file_num_total");
  GLADE_HOOKUP_OBJECT (window_send_files, label_file_dest, "label_file_dest");
  GLADE_HOOKUP_OBJECT (window_send_files, hseparator4, "hseparator4");
  GLADE_HOOKUP_OBJECT (window_send_files, hbuttonbox3, "hbuttonbox3");
  GLADE_HOOKUP_OBJECT (window_send_files, button_win_send_confirm, "button_win_send_confirm");
  GLADE_HOOKUP_OBJECT (window_send_files, alignment7, "alignment7");
  GLADE_HOOKUP_OBJECT (window_send_files, hbox9, "hbox9");
  GLADE_HOOKUP_OBJECT (window_send_files, image13, "image13");
  GLADE_HOOKUP_OBJECT (window_send_files, label36, "label36");
  GLADE_HOOKUP_OBJECT (window_send_files, button_win_send_cancel, "button_win_send_cancel");
  GLADE_HOOKUP_OBJECT (window_send_files, alignment8, "alignment8");
  GLADE_HOOKUP_OBJECT (window_send_files, hbox10, "hbox10");
  GLADE_HOOKUP_OBJECT (window_send_files, image14, "image14");
  GLADE_HOOKUP_OBJECT (window_send_files, label37, "label37");

  return window_send_files;
}

GtkWidget*
create_win_get_files (void)
{
  GtkWidget *win_get_files;
  GtkWidget *vbox8;
  GtkWidget *frame2;
  GtkWidget *alignment9;
  GtkWidget *vbox9;
  GtkWidget *label_files_machine;
  GtkWidget *label_files_time;
  GtkWidget *label41;
  GtkWidget *hseparator5;
  GtkWidget *scrolledwindow5;
  GtkWidget *clist_get_files;
  GtkWidget *label43;
  GtkWidget *label44;
  GtkWidget *hseparator6;
  GtkWidget *frame3;
  GtkWidget *alignment12;
  GtkWidget *scrolledwindow6;
  GtkWidget *textview_get_files;
  GtkWidget *label47;
  GtkWidget *hbuttonbox4;
  GtkWidget *button_save_files;
  GtkWidget *alignment10;
  GtkWidget *hbox11;
  GtkWidget *image15;
  GtkWidget *label45;
  GtkWidget *button_get_file_cancel;
  GtkWidget *alignment11;
  GtkWidget *hbox12;
  GtkWidget *image16;
  GtkWidget *label46;

  win_get_files = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (win_get_files, 400, 390);
  gtk_container_set_border_width (GTK_CONTAINER (win_get_files), 3);
  gtk_window_set_title (GTK_WINDOW (win_get_files), _("\346\224\266\345\210\260\346\226\207\344\273\266"));
  gtk_window_set_position (GTK_WINDOW (win_get_files), GTK_WIN_POS_CENTER);
  gtk_window_set_gravity (GTK_WINDOW (win_get_files), GDK_GRAVITY_CENTER);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (win_get_files), vbox8);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox8), frame2, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_NONE);

  alignment9 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment9);
  gtk_container_add (GTK_CONTAINER (frame2), alignment9);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment9), 0, 0, 12, 0);

  vbox9 = gtk_vbox_new (TRUE, 0);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (alignment9), vbox9);

  label_files_machine = gtk_label_new ("");
  gtk_widget_show (label_files_machine);
  gtk_box_pack_start (GTK_BOX (vbox9), label_files_machine, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_files_machine), GTK_JUSTIFY_CENTER);

  label_files_time = gtk_label_new ("");
  gtk_widget_show (label_files_time);
  gtk_box_pack_start (GTK_BOX (vbox9), label_files_time, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_files_time), GTK_JUSTIFY_CENTER);

  label41 = gtk_label_new (_("<b>\346\226\207\344\273\266\346\235\245\350\207\252</b>"));
  gtk_widget_show (label41);
  gtk_frame_set_label_widget (GTK_FRAME (frame2), label41);
  gtk_label_set_use_markup (GTK_LABEL (label41), TRUE);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox8), hseparator5, TRUE, TRUE, 0);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow5);
  gtk_box_pack_start (GTK_BOX (vbox8), scrolledwindow5, TRUE, TRUE, 0);
  gtk_widget_set_size_request (scrolledwindow5, -1, 129);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_SHADOW_IN);

  clist_get_files = gtk_clist_new (2);
  gtk_widget_show (clist_get_files);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), clist_get_files);
  gtk_clist_set_column_width (GTK_CLIST (clist_get_files), 0, 210);
  gtk_clist_set_column_width (GTK_CLIST (clist_get_files), 1, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (clist_get_files), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (clist_get_files));

  label43 = gtk_label_new (_("\346\226\207\344\273\266\345\220\215"));
  gtk_widget_show (label43);
  gtk_clist_set_column_widget (GTK_CLIST (clist_get_files), 0, label43);

  label44 = gtk_label_new (_("\345\244\247\345\260\217"));
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (clist_get_files), 1, label44);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_show (hseparator6);
  gtk_box_pack_start (GTK_BOX (vbox8), hseparator6, TRUE, TRUE, 0);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox8), frame3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame3, -1, 126);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_NONE);

  alignment12 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment12);
  gtk_container_add (GTK_CONTAINER (frame3), alignment12);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment12), 0, 0, 12, 0);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow6);
  gtk_container_add (GTK_CONTAINER (alignment12), scrolledwindow6);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_SHADOW_IN);

  textview_get_files = gtk_text_view_new ();
  gtk_widget_show (textview_get_files);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), textview_get_files);
  gtk_container_set_border_width (GTK_CONTAINER (textview_get_files), 3);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textview_get_files), GTK_WRAP_WORD);

  label47 = gtk_label_new (_("<b>\346\266\210\346\201\257:</b>"));
  gtk_widget_show (label47);
  gtk_frame_set_label_widget (GTK_FRAME (frame3), label47);
  gtk_label_set_use_markup (GTK_LABEL (label47), TRUE);

  hbuttonbox4 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox8), hbuttonbox4, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox4), GTK_BUTTONBOX_SPREAD);

  button_save_files = gtk_button_new ();
  gtk_widget_show (button_save_files);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button_save_files);
  GTK_WIDGET_SET_FLAGS (button_save_files, GTK_CAN_DEFAULT);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_save_files), FALSE);

  alignment10 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment10);
  gtk_container_add (GTK_CONTAINER (button_save_files), alignment10);

  hbox11 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (alignment10), hbox11);

  image15 = gtk_image_new_from_stock ("gtk-save-as", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image15);
  gtk_box_pack_start (GTK_BOX (hbox11), image15, FALSE, FALSE, 0);

  label45 = gtk_label_new_with_mnemonic (_("\345\217\246\345\255\230\344\270\272..."));
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox11), label45, FALSE, FALSE, 0);

  button_get_file_cancel = gtk_button_new ();
  gtk_widget_show (button_get_file_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button_get_file_cancel);
  GTK_WIDGET_SET_FLAGS (button_get_file_cancel, GTK_CAN_DEFAULT);

  alignment11 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment11);
  gtk_container_add (GTK_CONTAINER (button_get_file_cancel), alignment11);

  hbox12 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox12);
  gtk_container_add (GTK_CONTAINER (alignment11), hbox12);

  image16 = gtk_image_new_from_stock ("gtk-cancel", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image16);
  gtk_box_pack_start (GTK_BOX (hbox12), image16, FALSE, FALSE, 0);

  label46 = gtk_label_new_with_mnemonic (_("\345\217\226\346\266\210"));
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox12), label46, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) win_get_files, "show",
                    G_CALLBACK (on_win_get_files_show),
                    NULL);
  g_signal_connect ((gpointer) button_save_files, "clicked",
                    G_CALLBACK (on_button_save_files_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_get_file_cancel, "clicked",
                    G_CALLBACK (on_button_get_file_cancel_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_get_files, win_get_files, "win_get_files");
  GLADE_HOOKUP_OBJECT (win_get_files, vbox8, "vbox8");
  GLADE_HOOKUP_OBJECT (win_get_files, frame2, "frame2");
  GLADE_HOOKUP_OBJECT (win_get_files, alignment9, "alignment9");
  GLADE_HOOKUP_OBJECT (win_get_files, vbox9, "vbox9");
  GLADE_HOOKUP_OBJECT (win_get_files, label_files_machine, "label_files_machine");
  GLADE_HOOKUP_OBJECT (win_get_files, label_files_time, "label_files_time");
  GLADE_HOOKUP_OBJECT (win_get_files, label41, "label41");
  GLADE_HOOKUP_OBJECT (win_get_files, hseparator5, "hseparator5");
  GLADE_HOOKUP_OBJECT (win_get_files, scrolledwindow5, "scrolledwindow5");
  GLADE_HOOKUP_OBJECT (win_get_files, clist_get_files, "clist_get_files");
  GLADE_HOOKUP_OBJECT (win_get_files, label43, "label43");
  GLADE_HOOKUP_OBJECT (win_get_files, label44, "label44");
  GLADE_HOOKUP_OBJECT (win_get_files, hseparator6, "hseparator6");
  GLADE_HOOKUP_OBJECT (win_get_files, frame3, "frame3");
  GLADE_HOOKUP_OBJECT (win_get_files, alignment12, "alignment12");
  GLADE_HOOKUP_OBJECT (win_get_files, scrolledwindow6, "scrolledwindow6");
  GLADE_HOOKUP_OBJECT (win_get_files, textview_get_files, "textview_get_files");
  GLADE_HOOKUP_OBJECT (win_get_files, label47, "label47");
  GLADE_HOOKUP_OBJECT (win_get_files, hbuttonbox4, "hbuttonbox4");
  GLADE_HOOKUP_OBJECT (win_get_files, button_save_files, "button_save_files");
  GLADE_HOOKUP_OBJECT (win_get_files, alignment10, "alignment10");
  GLADE_HOOKUP_OBJECT (win_get_files, hbox11, "hbox11");
  GLADE_HOOKUP_OBJECT (win_get_files, image15, "image15");
  GLADE_HOOKUP_OBJECT (win_get_files, label45, "label45");
  GLADE_HOOKUP_OBJECT (win_get_files, button_get_file_cancel, "button_get_file_cancel");
  GLADE_HOOKUP_OBJECT (win_get_files, alignment11, "alignment11");
  GLADE_HOOKUP_OBJECT (win_get_files, hbox12, "hbox12");
  GLADE_HOOKUP_OBJECT (win_get_files, image16, "image16");
  GLADE_HOOKUP_OBJECT (win_get_files, label46, "label46");

  return win_get_files;
}

GtkWidget*
create_aboutdialog (void)
{
  GtkWidget *aboutdialog;
  const gchar *authors[] = {
    "\346\242\201\345\256\232 (\347\244\276\345\214\272ID : hunbuso) ",
    "\347\224\265\345\255\220\351\202\256\344\273\266 : hunbuso@gmail.com",
    "\344\270\255\345\233\275\345\234\260\350\264\250\345\244\247\345\255\246(\345\214\227\344\272\254) ",
    "\345\234\260\347\220\203\347\211\251\347\220\206\344\270\216\344\277\241\346\201\257\346\212\200\346\234\257\345\255\246\351\231\242",
    "\347\224\265\345\255\220\344\277\241\346\201\257\345\267\245\347\250\213\347\263\273 2003\345\261\212",
    "\350\275\257\344\273\266\345\217\221\345\270\203\344\271\213\346\227\245\344\272\216 \346\255\246\346\261\211 \344\273\273 Linux\345\272\224\347\224\250\347\250\213\345\272\217\345\267\245\347\250\213\345\270\210.",
    "********************************************",
    "\350\260\242\347\253\213\350\266\205  (\347\244\276\345\214\272ID : cugb_cat)",
    "\347\224\265\345\255\220\351\202\256\344\273\266 : xielichao1984@gmail.com ",
    "\344\270\255\345\233\275\345\234\260\350\264\250\345\244\247\345\255\246(\345\214\227\344\272\254) ",
    "\344\277\241\346\201\257\345\267\245\347\250\213\345\255\246\351\231\242 ",
    "\350\256\241\347\256\227\346\234\272\347\247\221\345\255\246\344\270\216\346\212\200\346\234\257\347\263\273 2003\345\261\212",
    "\350\275\257\344\273\266\345\217\221\345\270\203\344\271\213\346\227\245\344\272\216 \345\214\227\344\272\254 Linux\350\275\257\344\273\266\350\241\214\344\270\232\344\273\273\350\201\214.",
    "*********************************************",
    "\346\254\242\350\277\216\350\256\277\351\227\256\346\210\221\344\273\254\347\232\204\347\244\276\345\214\272,\350\216\267\345\217\226\346\234\200\346\226\260\347\232\204\350\275\257\344\273\266\345\271\266\347\233\270\344\272\222\344\272\244\346\265\201.\346\210\221\344\273\254\347\244\276\345\214\272\347\232\204\345\234\260\345\235\200\346\230\257:",
    "http://www.tofree.org/Forum/index.php",
    NULL
  };
  const gchar *documenters[] = {
    "hunbuso",
    NULL
  };
  const gchar *artists[] = {
    "hunbuso",
    NULL
  };
  /* TRANSLATORS: Replace this string with your names, one name per line. */
  gchar *translators = "hunbuso";

  aboutdialog = gtk_about_dialog_new ();
  gtk_widget_set_size_request (aboutdialog, 500, 250);
  gtk_container_set_border_width (GTK_CONTAINER (aboutdialog), 3);
  gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (aboutdialog), VERSION);
  gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (aboutdialog), _("CugbIpMsg-gtk"));
  gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG (aboutdialog), _("Copy Right \302\251 LinuxOpen 2006~2007"));
  gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (aboutdialog), _("\344\275\234\350\200\205:hunbuso  (hunbuso@gmail.com)\n              cugb_cat  (xielichao1984@gmail.com)"));
  gtk_about_dialog_set_license (GTK_ABOUT_DIALOG (aboutdialog), _("  This program is free software; you can redistribute it and/or modify  it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.\n  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for more details.\nYou should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA"));
  gtk_about_dialog_set_wrap_license (GTK_ABOUT_DIALOG (aboutdialog), TRUE);
  gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (aboutdialog), "http://www.tofree.org");
  gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG (aboutdialog), _("http://www.tofree.org"));
  gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (aboutdialog), authors);
  gtk_about_dialog_set_documenters (GTK_ABOUT_DIALOG (aboutdialog), documenters);
  gtk_about_dialog_set_artists (GTK_ABOUT_DIALOG (aboutdialog), artists);
  gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (aboutdialog), translators);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (aboutdialog, aboutdialog, "aboutdialog");

  return aboutdialog;
}

GtkWidget*
create_filechooserdialog_save_files (void)
{
  GtkWidget *filechooserdialog_save_files;
  GtkWidget *dialog_vbox2;
  GtkWidget *dialog_action_area2;
  GtkWidget *button_filechooserdialog_save_files_cancel;
  GtkWidget *button_filechooserdialog_save_files_open;

  filechooserdialog_save_files = gtk_file_chooser_dialog_new (_("\344\277\235\345\255\230\345\210\260"), NULL, GTK_FILE_CHOOSER_ACTION_SAVE, NULL);
  gtk_window_set_type_hint (GTK_WINDOW (filechooserdialog_save_files), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox2 = GTK_DIALOG (filechooserdialog_save_files)->vbox;
  gtk_widget_show (dialog_vbox2);

  dialog_action_area2 = GTK_DIALOG (filechooserdialog_save_files)->action_area;
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);

  button_filechooserdialog_save_files_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button_filechooserdialog_save_files_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog_save_files), button_filechooserdialog_save_files_cancel, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button_filechooserdialog_save_files_cancel, GTK_CAN_DEFAULT);

  button_filechooserdialog_save_files_open = gtk_button_new_from_stock ("gtk-save");
  gtk_widget_show (button_filechooserdialog_save_files_open);
  gtk_dialog_add_action_widget (GTK_DIALOG (filechooserdialog_save_files), button_filechooserdialog_save_files_open, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button_filechooserdialog_save_files_open, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) button_filechooserdialog_save_files_cancel, "clicked",
                    G_CALLBACK (on_button_filechooserdialog_save_files_cancel_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_filechooserdialog_save_files_open, "clicked",
                    G_CALLBACK (on_button_filechooserdialog_save_files_open_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_save_files, filechooserdialog_save_files, "filechooserdialog_save_files");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_save_files, dialog_vbox2, "dialog_vbox2");
  GLADE_HOOKUP_OBJECT_NO_REF (filechooserdialog_save_files, dialog_action_area2, "dialog_action_area2");
  GLADE_HOOKUP_OBJECT (filechooserdialog_save_files, button_filechooserdialog_save_files_cancel, "button_filechooserdialog_save_files_cancel");
  GLADE_HOOKUP_OBJECT (filechooserdialog_save_files, button_filechooserdialog_save_files_open, "button_filechooserdialog_save_files_open");

  gtk_widget_grab_default (button_filechooserdialog_save_files_open);
  return filechooserdialog_save_files;
}

GtkWidget*
create_dialog_overwrite_file_confirm (void)
{
  GtkWidget *dialog_overwrite_file_confirm;
  GtkWidget *dialog_vbox3;
  GtkWidget *vbox10;
  GtkWidget *label48;
  GtkWidget *image32;
  GtkWidget *label_overwrite_file_confirm;
  GtkWidget *dialog_action_area3;
  GtkWidget *cancelbutton_overwrite_file_cancel;
  GtkWidget *okbutton_overwrite_file_OK;

  dialog_overwrite_file_confirm = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog_overwrite_file_confirm), _("\350\257\267\346\261\202\347\241\256\350\256\244"));
  gtk_window_set_modal (GTK_WINDOW (dialog_overwrite_file_confirm), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (dialog_overwrite_file_confirm), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox3 = GTK_DIALOG (dialog_overwrite_file_confirm)->vbox;
  gtk_widget_show (dialog_vbox3);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), vbox10, TRUE, TRUE, 0);

  label48 = gtk_label_new ("");
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (vbox10), label48, FALSE, FALSE, 0);

  image32 = gtk_image_new_from_icon_name ("gtk-dialog-warning", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image32);
  gtk_box_pack_start (GTK_BOX (vbox10), image32, TRUE, TRUE, 0);

  label_overwrite_file_confirm = gtk_label_new ("");
  gtk_widget_show (label_overwrite_file_confirm);
  gtk_box_pack_start (GTK_BOX (vbox10), label_overwrite_file_confirm, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label_overwrite_file_confirm, -1, 118);
  GTK_WIDGET_SET_FLAGS (label_overwrite_file_confirm, GTK_CAN_FOCUS);
  gtk_label_set_justify (GTK_LABEL (label_overwrite_file_confirm), GTK_JUSTIFY_CENTER);
  gtk_label_set_selectable (GTK_LABEL (label_overwrite_file_confirm), TRUE);

  dialog_action_area3 = GTK_DIALOG (dialog_overwrite_file_confirm)->action_area;
  gtk_widget_show (dialog_action_area3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area3), GTK_BUTTONBOX_END);

  cancelbutton_overwrite_file_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton_overwrite_file_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog_overwrite_file_confirm), cancelbutton_overwrite_file_cancel, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton_overwrite_file_cancel, GTK_CAN_DEFAULT);

  okbutton_overwrite_file_OK = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton_overwrite_file_OK);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog_overwrite_file_confirm), okbutton_overwrite_file_OK, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton_overwrite_file_OK, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) dialog_overwrite_file_confirm, "show",
                    G_CALLBACK (on_dialog_overwrite_file_confirm_show),
                    NULL);
  g_signal_connect ((gpointer) cancelbutton_overwrite_file_cancel, "clicked",
                    G_CALLBACK (on_cancelbutton_overwrite_file_cancel_clicked),
                    NULL);
  g_signal_connect ((gpointer) okbutton_overwrite_file_OK, "clicked",
                    G_CALLBACK (on_okbutton_overwrite_file_OK_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_overwrite_file_confirm, dialog_overwrite_file_confirm, "dialog_overwrite_file_confirm");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_overwrite_file_confirm, dialog_vbox3, "dialog_vbox3");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, vbox10, "vbox10");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, label48, "label48");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, image32, "image32");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, label_overwrite_file_confirm, "label_overwrite_file_confirm");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_overwrite_file_confirm, dialog_action_area3, "dialog_action_area3");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, cancelbutton_overwrite_file_cancel, "cancelbutton_overwrite_file_cancel");
  GLADE_HOOKUP_OBJECT (dialog_overwrite_file_confirm, okbutton_overwrite_file_OK, "okbutton_overwrite_file_OK");

  return dialog_overwrite_file_confirm;
}

